# -*- perl -*-

#
# $Id: GDF.pm,v 1.3 2000/08/09 07:02:37 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 1998 Slaven Rezic. All rights reserved.
# This package is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: eserte@cs.tu-berlin.de
# WWW:  http://user.cs.tu-berlin.de/~eserte/
#

# GDF-Daten liegen hufig im Longitude/Latitude-Format nach WGS-84
# (einheitlicher Ellipsoid) vor. Dabei bezeichnen die Zahlen vor dem
# Komma die Grade und nach dem Komma die Dezimalstellen (nicht Minuten
# und Sekunden).

# Da bei der Telefonbuch-CDROM (1999) anscheinend die gleichen Daten
# mit einer geringeren Genauigkeit (2 Dezimalstellen weniger)
# verwendet wurden, werden hier einfach diese Daten verwendet.

package Karte::GDF;
use Karte;
use strict;
use vars qw(@ISA $obj);
use Karte::T99;

@ISA = qw(Karte);

sub new {
    my $class = shift;
    my $t99 = $Karte::T99::obj;
    my $self =
      {
       Name     => 'GDF-Koordinaten',
       Token    => 'gdf',
       Coordsys => 'W',

       X0 => -789351.104447435,
       X1 => 0.06760274161218,
       X2 => -0.0020260527650519,
       Y0 => -5801944.92780532,
       Y1 => 0.00122144839033196,
       Y2 => 0.110401509607961,

#         X0 => $t99->{X0},
#         X1 => $t99->{X1}/100,
#         X2 => $t99->{X2}/100,
#         Y0 => $t99->{Y0},
#         Y1 => $t99->{Y1}/100,
#         Y2 => $t99->{Y2}/100,

       Scrollregion => [13090316, 52339723, 13760339, 52673740],

      };
    bless $self, $class;
}

$obj = new Karte::GDF;

1;
