# -*- perl -*-

#
# $Id: GPS.pm,v 1.2 2000/01/30 23:26:54 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 1998 Slaven Rezic. All rights reserved.
# This package is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: eserte@cs.tu-berlin.de
# WWW:  http://user.cs.tu-berlin.de/~eserte/
#

# Das ist das Format von einem GPS-Empfnger (welchem?)
# Auch hier werden Longitude/Latitude-Daten verwendet. Die Kommastelle
# liegt hierbei nach der vierten Stelle. Wir knnen also hier die
# Telefonbuch-CDROM-Daten (1999) verwenden.

# XXX Der Name des Moduls wird evtl. um den Namen des Empfngers
# oder des Standard ergnzt.

# Die X0 etc.-Parameter basieren auf Dezimalgraden, die Ausgabe auf
# Grad/Minuten

package Karte::GPS;
use Karte;
use strict;
use vars qw(@ISA $obj);
use Karte::Polar;

@ISA = qw(Karte);

sub new {
    my $class = shift;
    my $t99 = $Karte::Polar::obj;
    my $self =
      {
       Name     => 'GPS-Koordinaten',
       Token    => 'gps',
       Coordsys => 'p',

       X0 => $t99->{X0},
       X1 => $t99->{X1},
       X2 => $t99->{X2},
       Y0 => $t99->{Y0},
       Y1 => $t99->{Y1},
       Y2 => $t99->{Y2},

#       Scrollregion => [13090316, 52339723, 13760339, 52673740],

      };
    bless $self, $class;
}

# XXX noch nicht zufriedenstellend... ist es berhaupt richtig? auerdem
# zu ungenau....
sub convert_to_route {
    my $file = shift;
    my @res;
    open(GPSTRACK, $file) or die "Can't open $file: $!";
    while(<GPSTRACK>) {
	chomp;
	if (m|^\$GPRMC|) {
	    my(@l) = split(',', $_);
	    my $breite_raw = $l[3]; # N is positive
	    my $ns         = $l[4];
	    my $laenge_raw = $l[5]; # E is positive
	    my $ew         = $l[6];
	    $breite_raw *= -1 if ($ns eq 'S');
	    $laenge_raw *= -1 if ($ew eq 'W');

	    my($breite_min, $breite_dec) = split(/\./, $breite_raw);
	    my($laenge_min, $laenge_dec) = split(/\./, $laenge_raw);
	    my($breite, $laenge);
	    $breite_min =~ /^(.*)(..)$/;
	    ($breite, $breite_min) = ($1, $2);
	    $laenge_min =~ /^(.*)(..)$/;
	    ($laenge, $laenge_min) = ($1, $2);

	    $breite_min = $breite_min/60;
	    $laenge_min = $laenge_min/60;
	    $breite_dec = ("0.".$breite_dec)/60;
	    $laenge_dec = ("0.".$laenge_dec)/60;
	    $breite += $breite_min + $breite_dec;
	    $laenge += $laenge_min + $laenge_dec;

	    my($x,$y) = $obj->map2standard($laenge, $breite);
	    if (!@res || ($x != $res[-1]->[0] ||
			  $y != $res[-1]->[1])) {
		push @res, [$x, $y];
	    }
	}
    }
    close GPSTRACK;
    @res;
}

$obj = new Karte::GPS;

1;
