# -*- perl -*-

#
# $Id: Radwege.pm,v 1.8 2000/11/28 01:45:58 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 1998 Slaven Rezic. All rights reserved.
# This package is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: eserte@cs.tu-berlin.de
# WWW:  http://user.cs.tu-berlin.de/~eserte/
#

package Radwege;

use strict;
use vars qw(%category_code %category_name %category_plural
	    %bez @category_order @bbbike_category_order);

my @category = 
  ('radweg'    => ['RW0', 'Radweg', 'Radwege'],
   'pflicht'   => ['RW1', 'benutzungspflichtig', 'benutzungspflichtige Radwege'],
   'suggestiv' => ['RW2', 'Suggestivstreifen'], # wird nicht verwendet
   'spur'      => ['RW3', 'Radstreifen'],
   'bus'       => ['RW4', 'Busspur', 'Busspuren'],
   'ruhig'     => ['RW5', 'verkehrsberuhigt'],
   'radstr'    => ['RW6', 'Fahrradstrae', 'Fahrradstraen'],
   'kein'      => [undef, 'kein Radweg', 'keine Radwege'],
  );

undef %category_code;         # "radweg" => "RW0"
undef %category_name;         # "radweg" => "Radweg"
undef %category_plural;       # "radweg" => "Radwege"
undef @category_order;        # ("radweg", "pflicht" ...)
undef @bbbike_category_order; # ("RW0", "RW1", ...)

for(my $i=0; $i<$#category; $i+=2) {
    my $rw_cat     = $category[$i];
    my $bbbike_cat = $category[$i+1]->[0];
    my $bez        = $category[$i+1]->[1];
    my $plural     = $category[$i+1]->[2] || $bez;
    $category_name{$rw_cat} = $bez
      if defined $bez;
    if (defined $plural) {
	$category_plural{$rw_cat} = $plural;
    }
    push @category_order, $rw_cat;
    if (defined $bbbike_cat) {
	$bez{$bbbike_cat} = $bez;
	$category_code{$rw_cat} = $bbbike_cat;
	push @bbbike_category_order, $bbbike_cat;
    } else {
	$bez{""} = $bez; # "kein"
	push @bbbike_category_order, "";
    }
}

1;
