#!/usr/bin/env perl
# -*- perl -*-

#
# $Id: bbbike.cgi,v 5.26 2000/12/01 02:44:38 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 1998, 1999, 2000 Slaven Rezic. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: eserte@cs.tu-berlin.de
# WWW:  http://user.cs.tu-berlin.de/~eserte/
#

use FindBin;
# Libraries mssen unten (Apache::) noch einmal aufgefhrt werden!
use lib ("/home/e/eserte/src/bbbike",
	 "$FindBin::RealBin/..", # falls normal installiert
	 "$FindBin::RealBin/../lib",
	 "$FindBin::RealBin/BBBike", # falls in .../cgi-bin/... installiert
	 "$FindBin::RealBin/BBBike/lib",
	);
use Strassen;
use BBBikeCalc;
use BBBikeVar;
use CGI;
use CGI::Carp qw(fatalsToBrowser confess);
use BrowserInfo;
use strict;
use vars qw($VERSION $VERBOSE $WAP_URL
	    $debug $tmp_dir $mapdir_fs $mapdir_url
	    $bbbike_root $bbbike_images $bbbike_html
	    $max_proc $use_miniserver $auto_switch_slow  $use_fcgi
	    $modperl_lowmem $use_imagemap $create_imagemap $q
	    $str $lstr $lstr2 $multistr $orte $orte2 $multiorte
	    $ampeln $qualitaet_s_net $strcat_net
	    %crossings $kr $plz $net $multi_bez_str
	    $use_umland $use_umland_jwd
	    $check_map_time $use_cgi_bin_layout
	    $show_weather $show_start_ziel_url @weather_cmdline
	    $bp_obj $bi $use_select
	    $graphic_format
	   );

# versucht, die C/XS-Version von make_net zu laden
eval q{local $SIG{'__DIE__'};
       # XXX warum gibt das hier Fehler auf stderr aus?
       # (nur bei 5.6.0?)
       use BBBikeXS;
   };

# CONFIG ###########################################################
# Konfigurationsvariablen mglichst in bbbike.cgi.config setzen!

# Die beiden folgenden Variablen mssen gendert werden, die anderen
# bei Bedarf.

# URL fr Verzeichnis, in dem die Imagemaps abgelegt werden
$mapdir_url = '/~eserte/bbbike-tmp';

# ... dazugehriger Filesystem-Pfad
$mapdir_fs  = '/home/e/eserte/www/bbbike-tmp';

# Mit ::OLD_AGREP = 1 wird das Verwenden von agrep verhindert
# (stattdessen wird versucht, String::Approx zu verwenden).
# agrep < 3.0 funktioniert nicht korrekt mit Umlauten.
$Strassen::OLD_AGREP = 1;
$PLZ::OLD_AGREP      = 1;
$PLZ::OLD_AGREP      = $PLZ::OLD_AGREP; # peacify -w

# im CS-Netz ist $ENV{PATH} beim Ausfhren als CGI-Skript leer
$ENV{PATH} = '' if !defined $ENV{PATH};
$ENV{PATH} = "/usr/bin:$ENV{PATH}"; # fr Sys::Hostname

# Temporres Verzeichnis fr Cache-Files, Wetterdaten etc.
$tmp_dir = $ENV{TMPDIR} || $ENV{TEMP} || "/tmp";

# TRUE, wenn der Miniserver verwendet werden soll
# XXX miniserver funktioniert nicht mehr?!
$use_miniserver = 0;

# Miniserver: Anzahl der maximal gleichzeitig laufenden Prozesse
$max_proc = 2;

# TRUE, wenn bei zu vielen MiniSvr-Prozessen automatisch auf das langsamere
# Interface geschaltet werden soll
$auto_switch_slow = 1;

# Falls Apache::Registry verwendet wird: TRUE, wenn die globalen
# Variablen nach Request-Ende gelscht werden sollen
$modperl_lowmem = 0;

# Falls berprft werden soll, ob die Imagemaps gegebber dem CGI-Programm
# und den Datenfiles noch aktuell sind.
# 0: keine berprfung
# 1: Check mit dem strassen-Datenfile
# 2: Check mit dem strassen-Datenfile und dem CGI-Programm
$check_map_time = 0;

# Wahr, wenn bei den Kartenquadranten eine Imagemap verwendet werden
# soll. Da dies anscheinend nur von Netscape unter FreeBSD/Linux
# untersttzt wird und auf anderen Systemen die Benutzung teilweise
# fatal ist, sollte diese Variable auf falsch gesetzt sein.
# $create_imagemap steuert die Erzeugung der Imagemap und kann ruhig auf
# wahr gesetzt werden.
$use_imagemap = 1; # XXX
$create_imagemap = 1;

# Zeigt die aktuellen Wetterdaten an.
$show_weather = 1;

# Gibt Links fr URLs auf Start/Ziel aus.
$show_start_ziel_url = 1;

# Verwendung des cgi-bin-Layouts, d.h. in cgi-bin ist nur bbbike.cgi, der
# Rest ist in cgi-bin/BBBike
$use_cgi_bin_layout = 0;

# Kommandozeile fr das Wetterprogramm
@weather_cmdline = ("$FindBin::RealBin/" . ($use_cgi_bin_layout
					    ? "BBBike" : "..") .
		    "/lib/wettermeldung2", qw(-dahlem1));

# Verwendung von <SELECT> statt <INPUT TYPE=RADIO>, wenn mglich
$use_select = 1;

# Experimentell: auch Suche von Landstraen im Umland
$use_umland = 0;

# ... und ganz weit weg ...
$use_umland_jwd = 0;

# For debugging: be verbose
$VERBOSE = 0;

# preferred graphic format: png or gif
# *** If using GD 1.20 or newer, this *must* be set to png, otherwise
# the creation of graphics will not work!
$graphic_format = 'gif';
#$graphic_format = 'png';

####################################################################

eval { local $SIG{'__DIE__'};
       #warn "$0.config";
       do "$0.config" };

if ($VERBOSE) {
    $StrassenNetz::VERBOSE    = $VERBOSE;
    $Strassen::VERBOSE        = $VERBOSE;
}

if ($use_miniserver) {
    eval q{
	local $SIG{'__DIE__'};
	#local $^W = 0; # XXX noch notwendig?
	require CGI::Base;
	require CGI::Request;
	require CGI::MiniSvr;

	package CGI::MiniSvr::BBBike;
	@CGI::MiniSvr::BBBike::ISA = qw(CGI::MiniSvr);
	# validate_peer ist eher strend ...
	# Probleme lokal beim Apache 1.3.4
	# (wahrscheinlich ein Konfigurationsproblem)
	sub validate_peer { return 1 }
    };

    warn __LINE__ .  ": Warnung: $@<br>\n" if $@;
}

if ($0 =~ /\.fcgi$/) {
    require FCGI;
    $use_fcgi = 1;
    exit if FCGI::accept() < 0;
}

# beim ersten Mal *darf* kein HTTP-Response-Header bermittelt werden, 
# danach *muss* es geschehen
use vars qw($first_time);
$first_time = 1;

{
# header() patchen
package CGI::BBBike;
@CGI::BBBike::ISA = qw(CGI);
sub new {
    my($class, @args) = @_;
    my $caller_pkg = caller();
    my $code = '
sub header
 {
    if (!$ ' . $caller_pkg . '::first_time && $ ' . $caller_pkg . '::use_miniserver) {
	print "HTTP/1.0 200 OK\n";
    }
    $ ' . $caller_pkg . '::first_time = 0;
    shift->SUPER::header(@_);
}
';
    eval $code;
    $class->SUPER::new(@args);
}

# damit ich weiterhin mit $q->... arbeiten kann
package CGI::Request::BBBike;
use vars qw(@ISA);
@ISA = qw(CGI::Request CGI::BBBike);

} # jetzt beginnt wieder package main

$VERSION = sprintf("%d.%02d", q$Revision: 5.26 $ =~ /(\d+)\.(\d+)/);

my $font = 'helvetica,arial';
my $delim = '!'; # wegen Mac nicht  verwenden!

#XXX delete:
#  use constant EMAIL    => 'eserte@cs.tu-berlin.de';
#  use constant EMAIL_OO => 'eserte@onlineoffice.de';
#  use constant HOMEPAGE => 'http://user.cs.tu-berlin.de/~eserte/';
#  use constant DISTDIR  => 'http://pub.cs.tu-berlin.de/src/BBBike/';
#  use constant WAP_URL  => 'http://www.onlineoffice.de/bbbike/wapbbbike.cgi';
#  #use constant WAP_URL  => '/~eserte/bbbike/cgi/wapbbbike.cgi';

my $std_css = <<EOF;
body,td,th { font-family:$font; }
tt { font-family:fixed; }
EOF
my @weak_cache = ('-expires' => '+1d',
                  # XXX ein bichen soll Netscape3 auch cachen knnen:
		  #'-pragma' => 'no-cache',
		  '-cache-control' => 'private',
                 );
my @no_cache = ('-expires' => 'now',
		'-pragma' => 'no-cache',
		'-cache-control' => 'no-cache',
               );

unshift(@Strassen::datadirs,
        "/home/e/eserte/src/bbbike/data", "$FindBin::RealBin/../data");

if (defined %Apache::) {
    # workaround for "use lib" problem with Apache::Registry
    lib->import("/home/e/eserte/src/bbbike", "$FindBin::RealBin/..",
	        "$FindBin::RealBin/../lib");
}

# Konstanten fr die Imagemaps
my $xgridwidth = 20; # 20 * 10 = 200: Breite und Hhe von berlin_small.gif
my $ygridwidth = 20;
my $xgridnr = 10;
my $ygridnr = 10;
my $xm = 228.58;
my $ym = $xm;
my $x0 = -10849;
my $y0 = 34867;
my $detailwidth  = 600; # mu quadratisch sein!
my $detailheight = 600;

$q = new CGI::BBBike;
$str = new Strassen "strassen" unless defined $str;
if ($use_umland) {

    # Strassen
    my @s = $str;
    $lstr  = new Strassen "landstrassen"  unless defined $lstr;
    push @s, $lstr;
    if ($use_umland_jwd) {
	$lstr2 = new Strassen "landstrassen2" unless defined $lstr2;
	push @s, $lstr2;
    }
    $multistr = new MultiStrassen @s unless defined $multistr;

    # Orte
    my @o;
    $orte = new Strassen "orte" unless defined $orte;
    push @o, $orte;
    if ($use_umland_jwd) {
	$orte2 = new Strassen "orte2" unless defined $orte2;
	push @o, $orte2;
    }
    $multiorte = new MultiStrassen @o unless defined $multiorte;

} else {
    $multistr = $str;
}

# Maximale Anzahl der angezeigten Straen, wenn eine Auswahl im PLZ-Gebiet
# gezeigt wird.
my $max = 25;

# Prozess-Tabelle
my %proc;

# die originale URL (fr den Kaltstart)
my $bbbike_url = $q->url;
# $mapdir_url absolut machen
$mapdir_url = "http://" . $q->server_name . $mapdir_url;
# Root-Verzeichnis und Bilder-Verzeichnis von bbbike
($bbbike_root = $bbbike_url) =~ s|[^/]*/[^/]*$|| if !defined $bbbike_root;
$bbbike_root =~ s|/$||; # letzten Slash abschneiden
if (!defined $bbbike_images) {
    $bbbike_images = "$bbbike_root/" . ($use_cgi_bin_layout ? "BBBike/" : "") .
	"images";
}
if (!defined $bbbike_html) {
    $bbbike_html   = "$bbbike_root/" . ($use_cgi_bin_layout ? "BBBike/" : "") .
	"html";
}

my($fontstr, $fontend);
my $smallform = 0;

if (!-d $mapdir_fs) {
    # unter der Voraussetzung, dass das Parent-Verzeichnis schon existiert
    mkdir $mapdir_fs, 0755;
}

my $bbbike_script = $q->url;
my $bbbike_script_cgi = $bbbike_script;
if ($use_fcgi) { # die normale CGI-Skript-Version (ohne FCGI)
    $bbbike_script_cgi =~ s/\.fcgi\b/.cgi/;
}

# den MiniSvr starten
my($cgi, $port);
if ($use_miniserver) {
    my $proc_slot = limit_processes();
    CGI::Base::LogFile("$tmp_dir/bbbike.log");
    chmod 0600, "$tmp_dir/bbbike.log";
    $cgi = new CGI::MiniSvr::BBBike;
    $port = $cgi->port;
    $bbbike_script_cgi = $bbbike_script
      = "http://$ENV{SERVER_NAME}$port$ENV{SCRIPT_NAME}";
    user_agent_info();
    choose_form();
    $cgi->done(0);
    $cgi->spawn and exit 0;
    # Prozessnummer korrigieren
    set_process($proc_slot);
    CGI::Request::Interface($cgi);
}

# Request-Loop
while (1) {
    if ($use_miniserver) {
	$q = new CGI::Request::BBBike or $cgi->exit;
	$q->delete("~SequenceNumber ");    # strt nur...
    } elsif ($use_fcgi) {
	# XXX workaround mit QUERY_STRING
	# scheint aber zu funktionieren
	$q = new CGI $ENV{QUERY_STRING};
    }

    # Bei Verwendung von FCGI oder Apache mu die User-Info immer
    # neu festgestellt werden
    user_agent_info() unless $use_miniserver;

    if ($bi->{'wap_browser'}) {
        exec("./wapbbbike.cgi", @ARGV);
	warn "exec failed, try redirect...";
	print $q->redirect($WAP_URL || $BBBike::BBBIKE_WAP);
	exit(0);
    }

    undef $bp_obj unless $use_miniserver;
    init_bikepower($q) if !($use_miniserver && defined $bp_obj);

    # Wettermeldungen so frh wie mglich versuchen zu holen
    if ($show_weather || $bp_obj) {
	start_weather_proc();
    }

    $q->delete('Dummy');
    $smallform = $q->param('smallform') || $bi->{'mobile_device'};

    foreach my $type (qw(start via ziel)) {
	if (defined $q->param($type . "charimg.x") and
	    $q->param($type . "charimg.x") ne ""   and
	    defined $q->param($type . "charimg.y") and
	    $q->param($type . "charimg.y") ne "") {
	    my($x, $y) = (int(($q->param($type . "charimg.x")-2)/30),
			  int(($q->param($type . "charimg.y")-2)/30));
	    my $ch = $x + $y*9 + ord("A");
	    $ch = ($ch > ord("Z") ? 'Z' : ($ch < ord("A") ? 'A' : chr($ch)));
	    $q->param($type . "char", $ch);
	    $q->delete($type . "charimg.x");
	    $q->delete($type . "charimg.y");
	}
    }

    if (defined $q->param('movemap')) {
	my $move = $q->param('movemap');
	my($x, $y) = ($q->param('detailmapx'), 
		      $q->param('detailmapy'));
	if    ($move =~ /^nord/i) { $y-- }
	elsif ($move =~ /^sd/i)  { $y++ }
	if    ($move =~ /west$/i) { $x-- }
	elsif ($move =~ /ost$/i)  { $x++ }
	$q->delete('detailmapx');
	$q->delete('detailmapy');
	$q->delete('movemap');
	draw_map('-x' => $x,
		 '-y' => $y);
	goto LOOP_CONT;
    }

    foreach my $type (qw(start via ziel)) {
	if (defined $q->param($type . "mapimg.x") and
	    $q->param($type . "mapimg.x") ne ""   and
	    defined $q->param($type . "mapimg.y") and
	    $q->param($type . "mapimg.y") ne "") {
	    my($x, $y) = (int($q->param($type . 'mapimg.x')/$xgridwidth),
			  int($q->param($type . 'mapimg.y')/$ygridwidth));
	    $q->param('type', $type);
	    $q->delete($type . "mapimg.x");
	    $q->delete($type . "mapimg.y");
	    draw_map('-x' => $x,
		     '-y' => $y);
	    goto LOOP_CONT;
	}
    }

    if (defined $q->param('detailmapx') and 
	defined $q->param('detailmapy') and
	defined $q->param('detailmap.x') and
	defined $q->param('detailmap.y')
       ) {
	my $c = detailmap_to_coord($q->param('detailmapx'),
				   $q->param('detailmapy'),
				   $q->param('detailmap.x'),
				   $q->param('detailmap.y'));
	if (defined $c) {
	    $q->param($q->param('type') . 'c', $c);
	}
	$q->delete('detailmapx');
	$q->delete('detailmapy');
	$q->delete('detailmap.x');
	$q->delete('detailmap.y');
	$q->delete('type');
    }

    # schwache stadtplandienst-Kompatibilitt
    if (defined $q->param('STR')) {
	$q->param('ziel', $q->param('STR'));
    }
    if (defined $q->param('PLZ')) {
	$q->param('zielplz', $q->param('PLZ'));
    }
    if (defined $q->param('LL')) {
	require Karte;
	Karte::preload("Standard", "Polar");
	my($long,$lat) = split(/x/, $q->param("LL"));
	if (defined $long && defined $lat) {
	    my($x, $y) = $Karte::Polar::obj->map2standard($long, $lat);
	    new_kreuzungen();
	    my(@nearest) = $kr->nearest_loop($x, $y);
	    $q->param("zielc", $nearest[0]);
	}
    }

    if (defined $q->param('begin')) {
	$q->delete('begin');
	choose_form();
    } elsif (defined $q->param('info')) {
	$q->delete('info');
	show_info();
    } elsif (defined $q->param('uploadpage') ||
	     defined $q->param('gps')) {
	$q->delete('uploadpage');
	$q->delete('gps');
	upload_button();
    } elsif (defined $q->param('all')) {
	$q->delete('all');
	choose_all_form();
    } elsif (defined $q->param('bikepower')) {
	$q->delete('bikepower');
	call_bikepower();
    } elsif (defined $q->param('nahbereich')) {
	nahbereich();
    } elsif (defined $q->param('routefile') and
	     $q->param('routefile') ne "") {
	draw_route_from_fh($q->param('routefile'));
    } elsif (defined $q->param('coords')) {
	draw_route();
    } elsif (defined $q->param('create_all_maps')) {
	# XXX Der Apache 1.3.9/FreeBSD 3.3 lsst den Prozess nach
	# ungefhr fnf Karten mit "Profiling timer expired" sterben.
	# Mit thttpd gibt es zwar auch mysterise kills, aber es geht im
	# Groen und Ganzen.
	print $q->header(-type => 'text/plain',
			 @no_cache,
			);
	$| = 1;
	$check_map_time = 1;
	for my $x (0 .. 9) {
	    for my $y (0 .. 9) {
		print "x=$x y=$y ...\n";
		draw_map('-x' => $x,
			 '-y' => $y,
			 '-quiet'    => 1,
			 '-logging'  => 1,
			 '-strlabel' => 1,
			 '-force'    => 0);
	    }
	}
	exit(0);
    } elsif (defined $q->param('startchar')) {
	choose_ch_form($q->param('startchar'), 'start');
    } elsif (defined $q->param('viachar')) {
	choose_ch_form($q->param('viachar'), 'via');
    } elsif (defined $q->param('zielchar')) {
	choose_ch_form($q->param('zielchar'), 'ziel');
    } elsif (defined $q->param('startc') and
	     defined $q->param('zielc')) {
	if (!$q->param('pref_seen')) {
	    # zuerst die Einstellungen fr die Suche eingeben lassen
	    get_kreuzung();
	} else {
	    # und erst dann suchen
	    search_coord();
	}
    } elsif (((defined $q->param('startname') and $q->param('startname') ne '')
	      or
	      (defined $q->param('startc') and $q->param('startc') ne ''))
	     and 
	     ((defined $q->param('zielname')  and $q->param('zielname')  ne '')
	      or
	      (defined $q->param('zielc') and $q->param('zielc') ne ''))
	     and
	     via_not_needed()
	    ) {
	get_kreuzung();
    } elsif (defined $q->param('browser')) {
	show_user_agent_info();
    } else {
	choose_form();
    }

  LOOP_CONT:
    if ($use_miniserver) {
	$cgi->done(0);
    } elsif ($use_fcgi) {
	FCGI::flush();
	exit 1 if FCGI::accept() < 0;
    } else {
	last;
    }
}

if ($modperl_lowmem) {
    # Nutzen fr den Speicherverbrauch ist eher begrenzt...
    undef $q;
    undef $str;
    undef $lstr;
    undef $lstr2;
    undef $multistr;
    undef $orte;
    undef $orte2;
    undef $multiorte;
    undef $plz;
    undef $net;
    undef $multi_bez_str;
}

sub choose_street_html {
    my($strasse, $plz_number, $type) = @_;
    if (!$plz) {
	require PLZ;
	$plz = new PLZ;
    }
    my $plz_re = $plz->make_plz_re($plz_number);
    my @res = $plz->look($plz_re, Noquote => 1);
    my @strres = $str->union(\@res);
    if (!@strres) {
	print "Keine Stra&szlig;en im PLZ-Gebiet $plz_number.<br>\n";
	print ucfirst($type) . ": <input type=text name=$type><br>\n";
    } else {
	print <<EOF;
<b>$strasse</b> ist nicht in der BBBike-Datenbank erfasst. Folgende
Stra&szlig;en sind im selben PLZ-Gebiet:<br>
EOF
        my @strname;
	for(my $i = 0; $i <= $#strres; $i++) {
	    push @strname, $str->get($strres[$i])->[0];
	    last if $i >= $max;
	}
	@strname = sort @strname;
	my $i = 0;
	my $strname;
	if ($use_select) {
	    print "<select name=" . $type . "name>";
	}
	foreach $strname(@strname) {
	    if ($use_select) {
		print "<option value=\"$strname\">$strname\n";
	    } else {
		print "<input type=radio name=" . $type . "name";
		if ($i == 0) {
		    print " checked";
		}
		print " value=\"$strname\"> $strname<br>\n";
		if ($i >= $max && $i < $#strres) {
		    print "...<br>\n";
		    last;
		}
	    }
	    $i++;
	}
	if ($use_select) {
	    print "</select><br>\n";
	}
	print "<input type=radio name=" . $type .
	  "name value=\"\"> <input type=text name=" . $type;
	if ($bi->{'can_javascript'}) {
	    print " onFocus='document.BBBikeForm.${type}name[document.BBBikeForm.${type}name.length-1].checked = true;'";
	}
	print "><br>\n";
    }
}

sub abc_link {
    my($type, %args) = @_;

    if ($bi->{'mobile_device'}) {
	# we don't need any extras
    } elsif ($bi->{'text_browser'}) {
	for my $ch ('A' .. 'Z') {
	    print "<input type=submit name=" 
	      . $type . "char value=" . $ch . ">";
	}
	print "<br>\n";
    } elsif ($bi->{'can_dhtml'} && !$bi->{'dhtml_buggy'} &&
	     $bi->{'can_javascript'} && $args{-nice}) {
	print "<input type=hidden name=\"" . $type . "charimg.x\" value=\"\">";
	print "<input type=hidden name=\"" . $type . "charimg.y\" value=\"\">";
	print "<div id=" . $type . "charbelow style=\"position:relative; visibility:hide\">";
	print "<img src=\"$bbbike_images/abc.gif\" border=0 width=270 height=94 alt=\"\">";
	print "</div>";
	print "<div id=" . $type . "charabove style=\"position:absolute; visibility:hide\">";
	print "<img src=\"$bbbike_images/abc_hi.gif\" border=0 width=270 height=94 alt=\"\">";
	print "</div>";
	print <<EOF;
<script language=javascript><!--
function $ {type}char_init() {
  if (document.layers) {
    if (!document.layers["${type}charabove"]) return;
    document.layers["${type}charabove"].visibility = 'hide';
    document.layers["${type}charbelow"].visibility = 'show';
    document.layers["${type}charabove"].pageX
      = document.layers["${type}charbelow"].pageX;
    document.layers["${type}charabove"].pageY
      = document.layers["${type}charbelow"].pageY;
    document.layers["${type}charbelow"].captureEvents(Event.MOUSEMOVE);
    document.layers["${type}charbelow"].onmousemove = $ {type}char_highlight;
    document.layers["${type}charabove"].onmouseout = $ {type}char_byebye;
    document.layers["${type}charabove"].captureEvents(Event.MOUSEUP);
    document.layers["${type}charabove"].onmouseup = $ {type}char_detail;
    all_above_layer[all_above_layer.length] = document.layers["${type}charabove"];
  } else if (document.all) {
    if (!document.all["${type}charabove"]) return;
    document.all["${type}charabove"].style.visibility = 'hidden';
    document.all["${type}charbelow"].style.visibility = 'visible';
    document.all["${type}charabove"].style.left
      = getOffsetLeft(document.all["${type}charbelow"]);
    document.all["${type}charabove"].style.top
      = getOffsetTop(document.all["${type}charbelow"]);
    document.all["${type}charbelow"].onmousemove = $ {type}char_highlight;
    document.all["${type}charabove"].onmouseout = $ {type}char_byebye;
    document.all["${type}charabove"].onmouseup = $ {type}char_detail;
    all_above_layer[all_above_layer.length] = document.all["${type}charabove"];
  }
}

function $ {type}char_highlight(Evt) {
  if (document.layers) {
    var above = document.layers["${type}charabove"];
    var below = document.layers["${type}charbelow"];
    below.captureEvents(Event.MOUSEMOVE);
    below.onmousemove = $ {type}char_highlight;
    var x = Math.floor((Evt.pageX-below.pageX)/30)*30;
    var y = Math.floor((Evt.pageY-below.pageY)/30)*30+4;
    with(above.clip) {
      left = x;
      top = y;
      right = x+30;
      bottom = y+30;
    }
    above.visibility = 'show';
    for (var x in all_above_layer) {
      if (all_above_layer[x] != above) all_above_layer[x].visibility = 'hide';
    }
  } else if (document.all) {
    var above = document.all["${type}charabove"];
    var below = document.all["${type}charbelow"];
    below.onmousemove = $ {type}char_highlight;
    var Evt = window.event;
    var x = Math.floor((Evt.offsetX-below.style.left)/30)*30;
    var y = Math.floor((Evt.offsetY-below.style.top)/30)*30+4;
    above.style.clip = "rect("+y+" "+(x+30)+" "+(y+30)+" "+x+")";
    above.style.visibility = 'visible';
    for (var x in all_above_layer) {
      if (all_above_layer[x] != above) all_above_layer[x].style.visibility = 'hidden';
    }
  }
}

function $ {type}char_byebye(Evt) {
  if (document.layers) {
    document.layers["${type}charabove"].visibility = 'hide';
  } else if (document.all) {
    document.all["${type}charabove"].visibility = 'hidden';
  }
}

function $ {type}char_detail(Evt) {
  if (document.layers) {
    document.BBBikeForm["${type}charimg.x"].value = Evt.layerX;
    document.BBBikeForm["${type}charimg.y"].value = Evt.layerY;
  } else if (document.all) {
    var Evt = window.event;
    document.BBBikeForm["${type}charimg.x"].value = Evt.offsetX;
    document.BBBikeForm["${type}charimg.y"].value = Evt.offsetY;
  }
  document.BBBikeForm.submit();
}

// --></script>

EOF

    } else {
	print "<input type=image name=" . $type 
	  . "charimg src=\"$bbbike_images/abc.gif\" border=0 width=270 height=94 alt=\"A..Z\">";
    }
}

sub choose_form () {
    my $startname = $q->param('startname') || '';
    my $start2    = $q->param('start2')    || '';
    my $start     = $q->param('start')     || '';

    my $vianame   = $q->param('vianame')   || '';
    my $via2      = $q->param('via2')      || '';
    my $via       = $q->param('via')       || '';

    my $zielname  = $q->param('zielname')  || '';
    my $ziel2     = $q->param('ziel2')     || '';
    my $ziel      = $q->param('ziel')      || '';

    # Namen und Koordinaten der Start...orte
    my($startort, $viaort, $zielort,
       $startortc, $viaortc, $zielortc);

    # Leerzeichen am Anfang und Ende lschen
    # berflssige Leerzeichen in der Mitte lschen
    $start =~ s/^\s+//; $start =~ s/\s+$//; $start =~ s/\s{2,}/ /g;
    $via   =~ s/^\s+//; $via   =~ s/\s+$//; $via   =~ s/\s{2,}/ /g;
    $ziel  =~ s/^\s+//; $ziel  =~ s/\s+$//; $ziel  =~ s/\s{2,}/ /g;

    foreach ([\$startname, \$start2, \$startort, \$startortc, 'start'],
	     [\$vianame,   \$via2,   \$viaort,   \$viaortc,   'via'],
	     [\$zielname,  \$ziel2,  \$zielort,  \$zielortc,  'ziel']) {
	my $nameref = $_->[0];
	my $tworef  = $_->[1];
	my $ortref  = $_->[2];
	my $ortcref = $_->[3];
	my $type    = $_->[4];
	# berprfen, ob eine in PLZ vorhandene Strae auch in
	# Strassen vorhanden ist und ggfs. $....name setzen
	if ($$nameref eq '' && $$tworef ne '') {
	    my(@s) = split(/$delim/o, $$tworef);
	    if ($s[1] eq '#ort') {
		my($ortname, $xy) = ($s[0], $s[2]);
		$$ortref  = $ortname;
		$$ortcref = $xy;
	    } else {
		my($strasse, $bezirk, $plz) = @s;
		warn "Whle $type-Strae fr $strasse/$bezirk\n" if $debug;
		my $pos = $str->choose_street($strasse, $bezirk);
		if (defined $pos) {
		    $$nameref = $str->get($pos)->[0];
		    $q->param($type . 'plz', $plz);
		}
	    }
	}
    }

    # Es ist alles vorhanden, keine Notwendigkeit fr ein Formular.
  TRY: {
	if (((defined $startname && $startname ne '') ||
	     (defined $startort  && $startort ne '')) &&
	    ((defined $zielname  && $zielname ne '') ||
	     (defined $zielort   && $zielort ne ''))) {
	    last TRY if (((defined $via2 && $via2 ne '') ||
			  (defined $via  && $via  ne '' && $via ne 'NO')) &&
			 ((!defined $vianame || $vianame eq '') &&
			  (!defined $viaort  || $viaort eq '')));

	    foreach ([\$startort, \$startortc, \$startname, 'start'],
		     [\$viaort,   \$viaortc,   \$vianame,   'via'],
		     [\$zielort,  \$zielortc,  \$zielname,  'ziel']) {
		my $ortref  = $_->[0];
		my $ortcref = $_->[1];
		my $nameref = $_->[2];
		my $type    = $_->[3];
		if ((!defined $$ortref || $$ortref ne '') and
		    defined $$ortcref) {
		    new_kreuzungen();
		    my($best) = $kr->nearest_loop(split(/,/, $$ortcref));
		    $q->param($type . 'isort', 1);
		    $q->param($type . 'c', $best);
		    $q->param($type . 'name', $$ortref);
		    $$nameref = $$ortref;
		}
	    }

	    if (0 && # XXX preferences-seite!
		$q->param("startc") and $q->param("zielc") and
		((!defined $vianame || $vianame eq '') ||
		 ($q->param("viac")))) {
		search_coord();
	    } else {
		warn "Whle Kreuzung fr $startname und $zielname\n"
		    if $debug;
		get_kreuzung($startname, $vianame, $zielname);
	    }
	    return;
	}
    }

    my(@start_matches, @via_matches, @ziel_matches);
    foreach ([\$startname, \$start, \$start2, \@start_matches, 'start'],
	     [\$vianame,   \$via,   \$via2,   \@via_matches,   'via'],
	     [\$zielname,  \$ziel,  \$ziel2,  \@ziel_matches,  'ziel']) {
	my $nameref  = $_->[0];
	my $oneref   = $_->[1];
	my $type     = $_->[4];

	# Darstellung eines Vias nicht erwnscht
	next if ($type eq 'via' and $$oneref eq 'NO');

	# berprfen, ob eine Strae in PLZ vorhanden ist.
	if ($$nameref eq '' && $$oneref ne '') {
	    my $tworef   = $_->[2];
	    my $matchref = $_->[3];
	    if (!$plz) {
		require PLZ;
		$plz = new PLZ;
		if (!$plz) {
		    # Notbehelf. PLZ sollte mglichst installiert sein.
		    my @res = $str->agrep($$oneref);
		    if (@res) {
			$$nameref = $res[0];
		    }
		    next;
		}
	    }

	    warn "Suche $$oneref in der PLZ-DB.\n" if $debug;
	    my($retref, $matcherr) =
	      $plz->look_loop($$oneref,
			      Max => $max, Agrep => 'default');
	    @$matchref = @$retref;
	    if (@$matchref == 0) {
		# Nichts gefunden. In der Pltze-Datei nachschauen.
		if (my $platz = new Strassen "plaetze") {
		    warn "Suche $$oneref in der Pltze-Datei.\n" if $debug;
		    my @res = $platz->agrep($$oneref);
		    if (@res) {
			my $ret = $platz->get_by_name($res[0]);
			if ($ret) {
			    $$nameref = $res[0];
			    $q->param($type . 'c', $ret->[1][0]);
			}
		    }
#XXX		    next;
		}
		if (!defined $$nameref) {
#XXX berprfen ...
		    # Noch immer ohne Erfolg. In der Strassen-Datei
		    # nachschauen, weil einige Straen nicht in der PLZ-Datei
		    # stehen.
		    warn "Suche $$oneref in der Straen-Datei.\n" if $debug;
		    my @res = $str->agrep($$oneref);
		    if (@res) {
			my $ret = $str->get_by_name($res[0]);
			if ($ret) {
			    $$nameref = $res[0];
			    $q->param($type . 'c', $ret->[1][0]);
			}
		    }
		}
		next;
	    }

	    # berprfen, ob es sich bei den gefundenen Straen um die
	    # gleiche Strae, die durch mehrere Bezirke verluft, handelt,
	    # oder ob es mehrere Straen in mehreren Bezirken sind, die nur
	    # den gleichen Namen haben.
	    if (@$matchref > 1) {
	      TRY: {
		    my $first = $matchref->[0][0];
		    for(my $i = 1; $i <= $#$matchref; $i++) {
			if ($first ne $matchref->[$i][0]) {
			    last TRY;
			}
		    }
		    # alle Straennamen sind gleich
		    if (!$multi_bez_str) {
			$multi_bez_str = new MultiBezStr;
		    }
		    if ($multi_bez_str) {
			my %bezirk;
			foreach ($multi_bez_str->bezirke($first)) {
			    $bezirk{$_}++;
			}
			foreach (@$matchref) {
			    last TRY if !exists $bezirk{$_->[1]};
			}
			splice @$matchref, 1;
		    }
		}
	    }

	    if ($multiorte) {
		my @orte = $multiorte->agrep($$oneref, Agrep => $matcherr);
		if (@orte) {
		    use constant MATCHREF_ISORT_INDEX => 4;
		    push @$matchref, map { [$_, undef, undef, undef, 1] } @orte;
		}
	    }

	    if (@$matchref == 1) {
		my($strasse, $bezirk) = ($matchref->[0][0],
					 $matchref->[0][1]);
		warn "Whle $type-Strae fr $strasse/$bezirk.\n"
		  if $debug;
		my $pos = $str->choose_street($strasse, $bezirk);
		if (defined $pos) {
		    $$nameref = $str->get($pos)->[0];
		    $q->param($type . 'plz', $matchref->[0][2]);
		} else {
		    $$tworef = join($delim, @{ $matchref->[0] });
		}
	    }
	}
    }

    # Es ist alles vorhanden, keine Notwendigkeit fr ein Formular.
  TRY: {
	if ($startname ne '' && $zielname ne '') {
	    last TRY if (((defined $via2 && $via2 ne '') ||
			  (defined $via  && $via  ne '')) &&
			 (!defined $vianame || $vianame eq ''));
	    warn "Whle Kreuzung fr $startname und $zielname\n"
	      if $debug;
	    get_kreuzung($startname, $vianame, $zielname);
	    return;
	}
    }

    my %header_args = @weak_cache;
    $header_args{-expires} = ($use_miniserver ? 'now' : '+1d');
    print $q->header(%header_args);
    my @extra_headers;
    if ($bi->{'text_browser'} && !$bi->{'mobile_device'}) {
	push @extra_headers, -up => $BBBike::HOMEPAGE;
    }
    my $nice_berlinmap = ($bi->{'can_dhtml'} && !$bi->{'dhtml_buggy'} &&
			  $bi->{'can_javascript'} && !$bi->{'text_browser'});
    if ($nice_berlinmap) {
	push @extra_headers, -onLoad => "init_hi()",
	     -script => "var all_above_layer = new Array();
function init_hi() {
  startmap_init();
  viamap_init();
  zielmap_init();
  startchar_init();
  viachar_init();
  zielchar_init();
}

function getOffsetLeft(o) {
  var par = 0;
  if (o.offsetParent)
    par = getOffsetLeft(o.offsetParent);
  return par + o.offsetLeft;
}
function getOffsetTop(o) {
  var par = 0;
  if (o.offsetParent)
    par = getOffsetTop(o.offsetParent);
  return par + o.offsetTop;
}
";
    }
    header(@extra_headers, -from => "chooseform");

    if ($start eq ''  && $ziel eq '' &&
	$start2 eq '' && $ziel2 eq '' &&
	$startname eq '' && $zielname eq '' &&
	!$smallform) {
 	print <<EOF;
<table>
<tr>
<td>Dieses Programm sucht (Fahrrad-)Routen in Berlin. Es sind ca. 2100
Stra&szlig;en eingetragen (alle Hauptstra&szlig;en und einige wichtige
Nebenstra&szlig;en).</td>
<td valign=top><small><a href="@{[ $BBBike::DISTDIR ]}">Download</a> der Perl/Tk-Version</small></td>
</tr>
</table>
<p>
EOF
        if ($bi->{'text_browser'}) {
            print q{<a name="navig"><a href="#start">Start-</a>};
            unless ($via eq 'NO') {
		print q{, <a href="#via">Via- (optional)</a> };
	    }
	    print <<EOF;
und <a href="#ziel">Zielstra&szlig;e</a>
der Route ausw&auml;hlen und dann <a href="#weiter">weiter</a>:</a><p>
EOF
        } else {
            print "Start- und Zielstra&szlig;e der Route ausw&auml;hlen";
	    unless ($via eq 'NO') { print " (Via ist optional)" }
	    print ": <p>\n";
        }
    }

    print "<form action=\"$bbbike_script\" name=BBBikeForm>\n";

    foreach 
      ([\$startname, \$start, \$start2, \$startort, \@start_matches, 'start'],
       [\$vianame,   \$via,   \$via2,   \$viaort,   \@via_matches,   'via'],
       [\$zielname,  \$ziel,  \$ziel2,  \$zielort,  \@ziel_matches,  'ziel']) {
	my $nameref   = $_->[0];
	my $oneref    = $_->[1];
	my $tworef    = $_->[2];
	my $ortref    = $_->[3];
	my $matchref  = $_->[4];
	my $type      = $_->[5];
	my $coord     = $q->param($type . "c");

	# Darstellung eines Vias nicht erwnscht
	if ($type eq 'via' and $$oneref eq 'NO') {
	    print "<input type=hidden name=via value=NO>";
	    next;
	}

	my $printtype = ucfirst($type);
	my $imagetype = "$bbbike_images/" . $type . ".gif";
	my $tryempty  = 0;
	my $no_td     = 0;

	print "<a name=\"$type\"></a>";
	if ($bi->{'can_table'}) {
	    print "<table>\n";
	    print "<tr><td valign=middle width=40><img src=\"$imagetype\" border=0 alt=\"$printtype\"></td>";
	} else {
	    print "$printtype ";
	}
	if ((defined $$nameref and $$nameref ne '') ||
	    (defined $coord and $coord ne '')) {
	    print "<td valign=middle>$fontstr" if $bi->{'can_table'};
	    if (defined $coord) {
		print "<input type=hidden name=" . $type . "c value=\"" 
		  . $coord . "\">\n";
	    }
	    if ($q->param($type . "isort")) {
		print "<input type=hidden name=" . $type . "isort value=1>\n";
	    }
	    if (defined $coord and (!defined $$nameref or $$nameref eq '')) {
		print crossing_text($coord);
	    } else {
		print "$$nameref\n";
	    }
	    print "<input type=hidden name=" . $type 
	      . "name value=\"$$nameref\">\n";
	    if (defined $q->param($type . "plz")) {
		print "<input type=hidden name=" . $type . "plz value=\"" 
		  . $q->param($type . "plz") . "\">\n";
	    }

	    print "$fontend</td>\n" if $bi->{'can_table'};
	} elsif (defined $$ortref and $$ortref ne '') {
	    print "<td valign=middle>$fontstr" if $bi->{'can_table'};
	    print "$$ortref\n";
	    print "<input type=hidden name=" . $type . "2 value=\""
		  . $$tworef . "\">\n";
	    print "</td>" if $bi->{'can_table'};
	    print "<input type=hidden name=" . $type . "isort value=1>\n";
	} elsif ($$oneref ne '' && @$matchref == 0) {
	    print "<td align=center>$fontstr" if $bi->{'can_table'};
	    print "<b>$$oneref</b> ist nicht bekannt.<br>\n";
	    $no_td = 1;
	    $tryempty = 1;
	} elsif ($$tworef ne '') {
	    my($strasse, $bezirk, $plz, $xy) = split(/$delim/o, $$tworef);
	    print "<td>$fontstr" if $bi->{'can_table'};
	    if (defined $xy) {
		new_kreuzungen();
		my $cr = crossing_text($xy);
		print "$cr";
		my($best) = $kr->nearest_loop(split(/,/, $xy));
		print "<input type=hidden name=" . $type .
		    "c value=\"$best\">";
		print "<input type=hidden name=" . $type .
		    "name value=\"$cr\">";
	    } else {
		choose_street_html($strasse,
				   $plz,
				   $type);
	    }
	    print "$fontend</td>" if $bi->{'can_table'};
	} elsif (@$matchref == 1) {
# XXX wann kommt man hierher?
	    print "<td>$fontstr" if $bi->{'can_table'};
	    choose_street_html($matchref->[0][0],
			       $matchref->[0][2],
			       $type);
	    print "$fontend</td>" if $bi->{'can_table'};
	} elsif (@$matchref > 1) {
	    print "<td>${fontstr}" if $bi->{'can_table'};
	    print "Genaue <b>" . $printtype .
	      "stra&szlig;e</b> ausw&auml;hlen:<br>\n";
	    my $s;
	    my $checked = 0;
	    foreach $s (@$matchref) {
		my $strasse2val;
		my $is_ort = $s->[MATCHREF_ISORT_INDEX];
		print "<input type=radio name=" . $type . "2";
		if ($is_ort && $multiorte) {
		    my($ret) = $multiorte->get_by_name($s->[0]);
use Data::Dumper; print STDERR "Line " . __LINE__ . ", File: " . __FILE__ . "\n" . Data::Dumper->Dumpxs([$ret],[]); # XXX

		    my $xy;
		    if ($ret) {
			$xy = $ret->[1][0];
		    }
		    $strasse2val = join($delim, $s->[0], "#ort", $xy);
		    $s->[0] =~ s/\|/ /; # Zusatzbezeichnung von Orten
		} else {
		    $strasse2val = join($delim, @$s); # 0..3
		}
		print " value=\"$strasse2val\"";
		if (!$checked) {
		    print " checked";
		    $checked++;
		}
		print "> $s->[0]";
		if (defined $s->[1] && defined $s->[2]) {
		    print " (<font size=-1>$s->[1], $s->[2]</font>)";
		}
		print "<br>\n";
	    }
	    print "$fontend</td>"  if $bi->{'can_table'};
	} else {
	    $tryempty = 1;
	}

	if ($tryempty) {
	    if (!$no_td) {
		print "<td align=center>" if $bi->{'can_table'};
	    }
	    print "<input type=text name=$type><br>";
	    if (!$smallform) {
		abc_link($type, -nice => 1);
		print "</td><td>" if $bi->{'can_table'};
		if ($nice_berlinmap) {
		    print "<input type=hidden name=\"" . $type . "mapimg.x\" value=\"\">";
		    print "<input type=hidden name=\"" . $type . "mapimg.y\" value=\"\">";
		    print "<div id=" . $type . "mapbelow style=\"position:relative;visibility:hide;\">";
		    print "<img src=\"$bbbike_images/berlin_small.gif\" border=0 width=200 height=200 alt=\"\">";
		    print "</div>";
		    print "<div id=" . $type . "mapabove style=\"position:absolute;visibility:hide;\">";
		    print "<img src=\"$bbbike_images/berlin_small_hi.gif\" border=0 width=200 height=200 alt=\"\">";
		    print "</div>";
		    print <<EOF;
<script language=javascript><!--
function $ {type}map_init() {
  if (document.layers) {
    if (!document.layers["${type}mapabove"]) return;
    document.layers["${type}mapabove"].visibility = 'hide';
    document.layers["${type}mapbelow"].visibility = 'show';
    document.layers["${type}mapabove"].pageX
      = document.layers["${type}mapbelow"].pageX;
    document.layers["${type}mapabove"].pageY
      = document.layers["${type}mapbelow"].pageY;
    document.layers["${type}mapbelow"].captureEvents(Event.MOUSEMOVE);
    document.layers["${type}mapbelow"].onmousemove = $ {type}map_highlight;
    document.layers["${type}mapabove"].onmouseout = $ {type}map_byebye;
    document.layers["${type}mapabove"].captureEvents(Event.MOUSEUP);
    document.layers["${type}mapabove"].onmouseup = $ {type}map_detail;
    all_above_layer[all_above_layer.length] = document.layers["${type}mapabove"];
  } else if (document.all) {
    document.all["${type}mapabove"].style.visibility = 'hidden';
    document.all["${type}mapbelow"].style.visibility = 'visible';
    document.all["${type}mapabove"].style.left
      = getOffsetLeft(document.all["${type}mapbelow"]);
    document.all["${type}mapabove"].style.top
      = getOffsetTop(document.all["${type}mapbelow"]);
    document.all["${type}mapbelow"].onmousemove = $ {type}map_highlight;
    document.all["${type}mapabove"].onmouseout = $ {type}map_byebye;
    document.all["${type}mapabove"].onmouseup = $ {type}map_detail;
    all_above_layer[all_above_layer.length] = document.all["${type}mapabove"];
  }
}

function $ {type}map_highlight(Evt) {
  if (document.layers) {
    var above = document.layers["${type}mapabove"];
    var below = document.layers["${type}mapbelow"];
    below.captureEvents(Event.MOUSEMOVE);
    below.onmousemove = $ {type}map_highlight;
    var x = Math.floor((Evt.pageX-below.pageX)/$xgridwidth)*$xgridwidth;
    var y = Math.floor((Evt.pageY-below.pageY)/$ygridwidth)*$ygridwidth-2;
    with(above.clip) {
      left = x;
      top = y;
      right = x+$xgridwidth;
      bottom = y+$xgridwidth;
    }
    above.visibility = 'show';
    for (var x in all_above_layer) {
      if (all_above_layer[x] != above) all_above_layer[x].visibility = 'hide';
    }
  } else if (document.all) {
    var above = document.all["${type}mapabove"];
    var below = document.all["${type}mapbelow"];
    below.onmousemove = $ {type}map_highlight;
    var Evt = window.event;
    var x = Math.floor((Evt.offsetX-below.style.left)/$xgridwidth)*$xgridwidth;
    var y = Math.floor((Evt.offsetY-below.style.top)/$ygridwidth)*$ygridwidth-2;
    above.style.clip = "rect("+y+" "+(x+$xgridwidth)+" "+(y+$ygridwidth)+" "+x+")";
    above.style.visibility = 'visible';
    for (var x in all_above_layer) {
      if (all_above_layer[x] != above) all_above_layer[x].style.visibility = 'hidden';
    }
  }
}

function $ {type}map_byebye(Evt) {
  if (document.layers) {
    document.layers["${type}mapabove"].visibility = 'hide';
  }
}

function $ {type}map_detail(Evt) {
  if (document.layers) {
    document.BBBikeForm["${type}mapimg.x"].value = Evt.layerX;
    document.BBBikeForm["${type}mapimg.y"].value = Evt.layerY;
  } else if (document.all) {
    var Evt = window.event;
    document.BBBikeForm["${type}mapimg.x"].value = Evt.offsetX;
    document.BBBikeForm["${type}mapimg.y"].value = Evt.offsetY;
  }
  document.BBBikeForm.submit();
}

// --></script>

EOF
		} elsif (!$bi->{'text_browser'}) {
		    print "<input type=image name=" . $type
		      . "mapimg src=\"$bbbike_images/berlin_small.gif\" border=0 width=200 height=200 alt=\"\">";
		}
		print "</td>" if $bi->{'can_table'};
	    }
	} elsif ($nice_berlinmap) {
            print "<script language=javascript><!--
function " . $type . "map_init() {}
function " . $type . "char_init() {}
//--></script>\n";
        }
	print "</table>\n" if $bi->{'can_table'};
	print "" . ($type eq 'ziel' ? "<p>" : '<hr>') . "\n";
    }

    hidden_smallform();
    print "<center>";
#<input type=submit value=\"&lt;&lt; Zurck\" onClick='javascript:history.back();'>
    print "<a name=\"weiter\"><input type=submit value=\"Weiter &gt;&gt;\"></a></center>";
    print "</form><hr>\n";
    if (!$smallform) {
	print window_open("$bbbike_script?all=1", "BBBikeAll",
			  "dependent,height=500,resizable," . 
			  "screenX=500,screenY=30,scrollbars,width=250");
	print "Liste aller bekannten Stra&szlig;en</a> (ca. 40 kB)<hr>\n";
    }
    footer();
    print $q->end_html;
}

sub choose_ch_form {
    my($search_char, $search_type) = @_;
    my $use_javascript = ($bi->{'can_javascript'} &&
			  !$bi->{'javascript_incomplete'});

    use locale;
    eval {
	local $SIG{'__DIE__'};
	require POSIX;
	foreach my $locale (qw(de de_DE de_DE.ISO8859-1 de_DE.ISO_8859-1)) {
	    # Aha. Bei &POSIX::LC_ALL gibt es eine Warnung, ohne & und mit ()
	    # funktioniert es reibungslos.
	    last if POSIX::setlocale( POSIX::LC_ALL(), $locale);
	}
    };
    print $q->header(@weak_cache);
    header();
    print "<b>" . ucfirst($search_type) . "</b>";
    print " (Anfangsbuchstabe <b>$search_char</b>)<br>\n";
    my $next_char =
      (ord($search_char) < ord('Z') ? chr(ord($search_char)+1) : undef);
    my $prev_char =
      (ord($search_char) > ord('A') ? chr(ord($search_char)-1) : undef);
    print "<form action=\"$bbbike_script\" name=Charform>\n";
    if (!$use_javascript) {
	print "<input type=submit value=\"Weiter &gt;&gt;\"><br>";
    }
    foreach ($q->param) {
	unless ($_ eq 'startchar' || $_ eq 'viachar' || $_ eq 'zielchar' ||
		$_ eq $search_type) {
	    # Lynx-Bug (oder Feature?): hidden-Variable werden nicht von
	    # der nachfolgenden Radio-Liste berschrieben
	    next if ($_ =~ /^$search_type/); 
	    print "<input type=hidden name=$_ value=\""
	      . $q->param($_) . "\">\n";
	}
    }

    my $regex_char = "^" . ($search_char eq 'A' 
			    ? '[A]'
			    : ($search_char eq 'O'
			       ? '[O]'
			       : ($search_char eq 'U'
				  ? '[U]'
				  : $search_char)));
    my @strlist;
    $str->init;
    eval q{ # eval wegen /o
	while(1) {
	    my $ret = $str->next;
	    last if !@{$ret->[1]};
	    my $name = $ret->[0];
	    push(@strlist, $name) if $name =~ /$regex_char/oi;
	}
    };
    @strlist = sort @strlist;

    print
      "<input type=radio name=" . $search_type . "name value=\"\"" ,
      ($use_javascript ? " onclick=\"document.Charform.submit()\"" : ""),
      "> ",
      ($use_javascript ? "(Zurck zum Eingabeformular)" : "(nicht gesetzt)"),
      "<br>\n";

    my $last_name;
    for(my $i = 0; $i <= $#strlist; $i++) {
	my $name = $strlist[$i];
	if (defined $last_name and $name eq $last_name) {
	    next;
	} else {
	    $last_name = $name;
	}
	print
	  "<input type=radio name=" . $search_type . "name value=\"$name\"",
	  ($use_javascript ? " onclick=\"document.Charform.submit()\"" : ""),
	  "> ",
	  $name,
	  "<br>\n";
    }

    print "<br>";
    if (!$use_javascript) {
	print "<input type=submit value=\"Weiter &gt;&gt;\"><br><br>\n";
    }
    print "andere " . ucfirst($search_type) . "stra&szlig;e:<br>\n";
    abc_link($search_type);
    print "</form>\n";
    footer();
    print $q->end_html;
}

sub choose_all_form {

    use locale;
    eval {
	local $SIG{'__DIE__'};
	require POSIX;
	foreach my $locale (qw(de de_DE de_DE.ISO8859-1 de_DE.ISO_8859-1)) {
	    last if (&POSIX::setlocale( &POSIX::LC_ALL, $locale));
	}
    };

    print $q->header(@weak_cache);
    header();

    my @strlist;
    $str->init;
    while(1) {
	my $ret = $str->next;
	last if !@{$ret->[1]};
	push(@strlist, $ret->[0]);
    }
    @strlist = sort @strlist;
    my %initial = ('' => 'A',
		   '' => 'O',
		   '' => 'U');
    my $last = "";
    my $last_initial = "A";

    print "<center>";
    for my $ch ('A' .. 'Z') {
	print "<a href=\"#$ch\">$ch</a> ";
    }
    print "</center><p>";

    for(my $i = 0; $i <= $#strlist; $i++) {
	next if ($strlist[$i] =~ /^\(/);
	next if $last eq $strlist[$i];
	$last = $strlist[$i];
	(my $strname = $strlist[$i]) =~ s/\s+/\240/g;
	my $initial = substr($strname, 0, 1);
	if (defined $last_initial and
	    $last_initial ne $initial and
	    (!defined $initial{$initial} or
	     $last_initial ne $initial{$initial})) {
	    print "<hr>";
	    $last_initial = ($initial{$initial} ? $initial{$initial} : $initial);
	    print "<a name=\"$last_initial\">$strname</a><br>\n";
	} else {
	    print "$strname<br>\n";
	}
    }
    print $q->end_html;
}

sub get_kreuzung {
    my($start_str, $via_str, $ziel_str) = @_;
    if (!defined $start_str) {
	$start_str = $q->param('startname');
    }
    if (!defined $via_str) {
	$via_str = $q->param('vianame');
    }
    if (!defined $ziel_str) {
	$ziel_str  = $q->param('zielname');
    }
    my $start_plz = $q->param('startplz');
    my $via_plz   = $q->param('viaplz');
    my $ziel_plz  = $q->param('zielplz');

    my $start_c   = $q->param('startc');
    my $via_c     = $q->param('viac');
    my $ziel_c    = $q->param('zielc');

    my %is_ort;
    foreach (qw(start via ziel)) {
	$is_ort{$_} = $q->param($_ . 'isort');
    }

    my($start, $via, $ziel);
    my(@start_coords, @via_coords, @ziel_coords);

    $str->init;
    # XXX Abbruch knnte etwas frher erfolgen, und zwar bei
    # definiertem ziel und start und nchste Strae ist weder start
    # noch ziel
    while(1) {
	my $ret = $str->next;
	last if !@{$ret->[1]};
	my $name = $ret->[0];
	if (defined $start_str && $start_str eq $name and !defined $start_c) {
	    $start   = $str->pos;
	    push @start_coords, @{$ret->[1]};
	}
	if (defined $via_str && $via_str eq $name and !defined $via_c) {
	    $via     = $str->pos;
	    push @via_coords, @{$ret->[1]};
	}
	if (defined $ziel_str && $ziel_str  eq $name and !defined $ziel_c) {
	    $ziel   = $str->pos;
	    push @ziel_coords, @{$ret->[1]};
	}
    }

    if (!defined $start and !defined $start_c) {
	confess "Fehler: Start $start kann nicht zugeordnet werden.<br>\n";
    }
    if (!defined $ziel  and !defined $ziel_c) {
	confess "Fehler: Ziel $ziel kann nicht zugeordnet werden.<br>\n";
    }

    if (@start_coords == 1 and @ziel_coords == 1 and
	(@via_coords == 1 or !defined $via)) {
	# nur eine Kreuzung fr alle Punkte vorhanden
	# => gleich zur Suche springen
	$q->param('startc', $start_coords[0]);
	$q->param('startname', $start_str);
	$q->param('zielc',  $ziel_coords[0]);
	$q->param('zielname', $ziel_str);
	if (defined $via) {
	    $q->param('viac',  $via_coords[0]);
	    $q->param('vianame', $via_str);
	}
#	search_coord(); # XXX preferences-seite!
#	exit(0);
    }

    print $q->header(@weak_cache);
    header();
    print "Genaue Kreuzung angeben:<p>\n";

    all_crossings();

    print "<form action=\"$bbbike_script\">";
    foreach ([$start_str, \@start_coords, $start_plz, $start_c, 'start'],
	     [$via_str,   \@via_coords,   $via_plz,   $via_c,   'via'],
	     [$ziel_str,  \@ziel_coords,  $ziel_plz,  $ziel_c,  'ziel'],
	    ) {
	my $strname   = $_->[0];
	my @coords    = @{$_->[1]};
	my $plz       = $_->[2];
	my $c         = $_->[3];
	my $type      = $_->[4];
	next if !@coords and !$c; # kann bei nicht definiertem Via vorkommen
	my $printtype = ucfirst($type);
	print "<b>$printtype</b>: ";
	if (@coords == 1) {
	    $c = $coords[0];
	}
	if (defined $c) {
	    print "<input type=hidden name=" . $type . "c value=\"$c\">";
	}
	if (defined $c and (not defined $strname or $strname eq '')) {
	    print crossing_text($c) . "<br>\n";
	} else {
	    if (defined $plz and $plz eq '') {
		print $strname;
	    } else {
		print stadtplan_link($strname, $plz, $is_ort{$type});
	    }
	}
	# Parameter durchschleifen...
	if (defined $strname) {
	    print "<input type=hidden name=" . $type .
	      "name value=\"$strname\">";
	}
	if (defined $q->param($type . "plz")) {
	    print "<input type=hidden name=" . $type . "plz value=\"" .
	      $q->param($type . "plz") . "\">\n";
	}
	if ($is_ort{$type}) {
	    print "<input type=hidden name=" . $type . "isort value=1>\n";
	}
	if (!defined $c) {
	    my $i = 0;
	    my %used;
	    my $ecke_printed = 0;
	    foreach (@coords) {
		unless ($ecke_printed) {
		    if ($use_select) {
			print " Ecke <select name=" . $type . "c>";
		    } else {
			print " Ecke ...<br>\n";
		    }
		    $ecke_printed++;
		}
		if ($used{$_}) {
		    next;
		} else {
		    $used{$_}++;
		}
		if (exists $crossings{$_}) {
		    if ($use_select) {
			print "<option value=\"$_\">";
		    } else {
			print
			  "<input type=radio name=" . $type . "c ",
			  "value=\"$_\"";
			if ($i++ == 0) {
			    print " checked";
			}
			print "> ";
		    }
		    my @kreuzung;
		    foreach (@{$crossings{$_}}) {
			if ($_ ne $strname) {
			    push(@kreuzung, $_);
			}
		    }
		    if (@kreuzung == 0) {
			print "..."; # XXX bessere Loesung?
		    } else {
			print join("/", @kreuzung);
		    }
		    print "<br>" unless $use_select;
		    print "\n";
		}
	    }
	    print "</select>" if $use_select && $ecke_printed;
	}
	print "" . ($type ne 'ziel' ? '<hr>' : '<br><br>') . "\n";
    }
    hidden_smallform();

    # Einstellungen ########################################
    print <<EOF;
<hr><b>Einstellungen</b>:<br>
EOF
    if ($bi->{'can_javascript'}) {
	print <<EOF;
<script><!--
function reset_form() {
    with (document.forms[0]) {
	elements["pref_speed"].value = 20;
	elements["pref_cat"].options[0].selected = true;
	elements["pref_quality"].options[0].selected = true;
	elements["pref_ampel"].checked = false;
    }
    return false;
}
//--></script>
EOF
    }
    print <<EOF;
<input type=hidden name=pref_seen value=1>
<table>
<tr><td>Bevorzugte Geschwindigkeit:</td><td><input type=text width=4 size=2 name=pref_speed value="20"> km/h</td></tr>
<tr><td>Bevorzugter Straentyp:</td><td><select name=pref_cat>
<option value="">egal
<option value="N1">Nebenstraen bevorzugen
<option value="N2">nur Nebenstraen benutzen
<option value="H1">Hauptstraen bevorzugen
<option value="H2">nur Hauptstraen benutzen
</select></td></tr>
<tr><td>Bevorzugter Straenbelag:</td><td><select name=pref_quality>
<option value="">egal
<option value="Q0">nur sehr gute Belge bevorzugen
<option value="Q2">Kopfsteinpflaster vermeiden
</select></td></tr>
<!--XXX implement <tr><td>Radwege:</td><td><select name=pref_rw>
<option value="">egal
<option value="R0">nur Radwege verwenden
<option value="R1">Hauptstraen mit Radweg bevorzugen
<option value="R2">benutzungspflichtige Radwege vermeiden
</select></td></tr>-->
<tr><td>Ampeln vermeiden:</td><td><input type=checkbox name=pref_ampel value=yes></td>
EOF
    if ($bi->{'can_javascript'}) {
	print <<EOF
<td><input type=button value="Voreinstellungen" onclick="return reset_form();"></td>
EOF
    }
print <<EOF;
</tr>
</table>
<hr>
EOF
    suche_button();
    # probably tkweb - work around form submit bug
    if ($q->user_agent !~ m|libwww-perl|) {
	print " <font size=\"-1\"><input type=submit name=nahbereich value=\"Nahbereich\"></font>\n";
    }
    footer();
    print $q->end_html;
}

sub nahbereich {
    my($startc, $zielc, $startname, $zielname) =
      ($q->param('startc'), $q->param('zielc'),
       $q->param('startname'),$q->param('zielname'));
    print $q->header(@weak_cache);
    header();
    print "Kreuzung im Nahbereich angeben:<p>\n";
    new_kreuzungen();
    my($startx, $starty) = split(/,/, $startc);
    my($zielx,  $ziely)  = split(/,/, $zielc);
    print "<form action=\"$bbbike_script\">";
    print "<b>Start</b>:<br>\n";
    print "<input type=hidden name=startname value=\"$startname\">";
    my $i = 0;
    foreach ($kr->nearest_loop($startx, $starty)) {
	print "<input type=radio name=startc value=\"$_\"";
	if ($i++ == 0) {
	    print " checked";
	}
	print "> ", join("/", @{$crossings{$_}}), "<br>\n";
    }
    print "<hr>";
    print "<input type=hidden name=zielname value=\"$zielname\">";
    print "<b>Ziel</b>:<br>\n";
    $i = 0;
    foreach ($kr->nearest_loop($zielx, $ziely)) {
	print "<input type=radio name=zielc value=\"$_\"";
	if ($i++ == 0) {
	    print " checked";
	}
	print "> ", join("/", @{$crossings{$_}}), "<br>\n";
    }
    print "<hr>";
    suche_button();
    print "</form>";
    footer();
    print $q->end_html;
}

sub suche_button {
    print "<input type=submit value=\"Suche starten &gt;&gt;\">\n";
}

sub hidden_smallform {
    # Hier die Query-Variable statt der Perl-Variablen benutzen...
    if ($q->param('smallform')) {
	print "<input type=hidden name=smallform value=\"" .
	  $q->param('smallform') . "\">\n";
    }
}

sub via_not_needed {
    my($via, $via2, $vianame) = @_;
    $via     = $q->param('via')     if !defined $via;
    $via2    = $q->param('via2')    if !defined $via2;
    $vianame = $q->param('vianame') if !defined $vianame;

    !(((defined $via2 && $via2 ne '') ||
       (defined $via  && $via  ne '' && $via ne 'NO')) &&
      (!defined $vianame || $vianame eq ''));
}

sub make_netz {
    my $lite = shift;
    if (!$net) {
	$net = new StrassenNetz $multistr;
	# XXX berprfen, ob sich der Cache lohnt...
	# evtl. mit IPC::Shareable arbeiten (Server etc.)
	$net->make_net(UseCache => 1);
	if (!$lite) {
	    $net->make_sperre('gesperrt',
			      Type => ['einbahn', 'sperre',
				       'tragen', 'wegfuehrung']);
	}
    }
    $net;
}

sub search_coord {
    my $startcoord  = $q->param('startc');
    my $viacoord    = $q->param('viac');
    my $zielcoord   = $q->param('zielc');
    my $startname   = name_from_cgi($q, 'start');
    my $vianame     = name_from_cgi($q, 'via');
    my $zielname    = name_from_cgi($q, 'ziel');
    my $alternative = $q->param('alternative');
    my $printmode   = $q->param('printmode');

    my $printwidth  = 400;
    my $fontstr     = ($printmode
		       ? "<font face=\"$font\" size=\"-2\">"
		       : $fontstr);

    make_netz();

    ($startcoord, $viacoord, $zielcoord)
      = fix_coords($startcoord, $viacoord, $zielcoord);

    my @r;
    my $via_array = (defined $viacoord && $viacoord ne ''
		     ? [$viacoord]
		     : []);

    my %extra_args;
    if (@$via_array) {
	$extra_args{Via} = $via_array;
	# siehe Kommentar in new_search: Via und All beien sich
    } else {
	$extra_args{All} = 1;
    }

    # Ampeloptimierung
    if ($q->param('pref_ampel') && $q->param('pref_ampel') eq 'yes') {
	if (!$ampeln) {
	    my $lsa = new Strassen "ampeln";
	    $lsa->init;
	    while(1){
		my $ret = $lsa->next;
		last if !@{$ret->[1]};
		my($xy) = $ret->[1][0];
		$ampeln->{$xy}++;
	    }
	}
	$extra_args{Ampeln} = {Net     => $ampeln,
			       Penalty => 100};
    }

    # Qualittsoptimierung
    if ($q->param('pref_quality') ne '') {
	# XXX landstraen?
	if (!$qualitaet_s_net) {
	    $qualitaet_s_net =
		new StrassenNetz(Strassen->new("qualitaet_s"));
	    $qualitaet_s_net->make_net_cat;
	}
	my $penalty;
	if ($q->param('pref_quality') eq 'Q2') {
	    $penalty = { "Q0" => 1,
			 "Q1" => 1.2,
			 "Q2" => 1.6,
			 "Q3" => 2 };
	} else {
	    $penalty = { "Q0" => 1,
			 "Q1" => 1,
			 "Q2" => 1.5,
			 "Q3" => 1.8 };
	}
	$extra_args{Qualitaet} =
	    {Net => $qualitaet_s_net,
	     Penalty => $penalty,
	    };

    }

    # Kategorieoptimierung
    if ($q->param('pref_cat') ne '') {
	if (!$strcat_net) {
	    $strcat_net = new StrassenNetz $multistr;
	    $strcat_net->make_net_cat;
	}
	my $penalty;
	if ($q->param('pref_cat') eq 'N2') {
	    $penalty = { "HH" => 4,
			 "H"  => 4,
			 "N"  => 1,
			 "NN" => 1 };
	} elsif ($q->param('pref_cat') eq 'N1') {
	    $penalty = { "HH" => 1.5,
			 "H"  => 1.5,
			 "N"  => 1,
			 "NN" => 1 };
	} elsif ($q->param('pref_cat') eq 'H1') {
	    $penalty = { "HH" => 1,
			 "H"  => 1,
			 "N"  => 1.5,
			 "NN" => 1.5 };
	} else { # $q->param('pref_cat') eq 'H2'
	    $penalty = { "HH" => 1,
			 "H"  => 1,
			 "N"  => 4,
			 "NN" => 4 };
	}
	$extra_args{Strcat} =
	    {Net => $strcat_net,
	     Penalty => $penalty,
	    };
    }

    my(@r) = $net->new_search($startcoord, $zielcoord,
			      AsObj => 1,
			      %extra_args);

#XXX Bse Falle, wenn ein Punkt wegen make_sperre nicht erreichbar ist
# Dann gibt es natrlich keine Route.
# Lsung: all_crossings mte Sperren vom Typ 0 (Tragen) und 1 (totale
# Sperre) ausschlieen
# Das knnte etwas komplizierter werden.
# Lsungsstrategie: modifiziertes data/strassen erzeugen, das keine
# gesperrten Stcke mehr enthlt
# Unschn!
#
    my(@weather_res);
    if ($show_weather || $bp_obj) {
	@weather_res = gather_weather_proc();
    }

    print $q->header(@weak_cache);
    my %header_args;
##XXX die Idee hierbei war: table.background ist bei Netscape der Hintergrund
## ohne cellspacing, whrend es beim IE mit cellspacing ist. Also fr
## jedes td bgcolor setzen. Oder besser mit Stylesheets arbeiten. Nur wie, 
## wenn man nicht fr jedes td die Klasse setzen will?
#     if ($can_css) {
# 	$header_args{'-style'} = <<EOF;
# <!--
# $std_css
# td { background:#ffcc66; }
# -->
# EOF
#     }
    header(%header_args);

    if (!@r) {
	print "Keine Route gefunden.\n";
    } else {
	my $r;
	if (defined $alternative &&
	    $alternative >= 0 && $alternative <= $#r) {
	    $r = $r[$alternative];
	} else {
	    $r = $r[0];
	}
	if (!$r->path_list) {
	    print "Keine Route gefunden.\n";
	} # XXX else-Teil fehlt

	my(@power) = (50, 100, 200);
	my @bikepwr_time = (0, 0, 0);
	use vars qw($wind_dir $wind_v %wind_dir $wind); # XXX oben definieren
	if ($bp_obj && @weather_res && exists $wind_dir{lc($weather_res[4])}) {
	    analyze_wind_dir($weather_res[4]);
	    $wind = 1;
	    $wind_v = $weather_res[7];
	    my(@path) = $r->path_list;
	    for(my $i = 0; $i < $#path; $i++) {
		my($x1, $y1) = @{$path[$i]};
		my($x2, $y2) = @{$path[$i+1]};
		my($deltax, $deltay) = ($x1-$x2, $y1-$y2);
		my $etappe = sqrt(sqr($deltax) + sqr($deltay));
		next if $etappe == 0;
# XXX feststellen, warum hier ein Minus stehen mu...
		my $hw = -head_wind($deltax, $deltay);
		# XXX Doppelung mit bbbike-Code vermeiden
		my $wind; # Berechnung des Gegenwindes
		if ($hw >= 2) {
		    $wind = -$wind_v;
		} elsif ($hw > 0) { # unsicher beim Crosswind
		    $wind = -$wind_v*0.7;
		} elsif ($hw > -2) {
		    $wind = $wind_v*0.7;
		} else {
		    $wind = $wind_v;
		}
		for my $i (0 .. 2) {
		    # XXX Hhenberechnung nicht vergessen
		    # XXX Doppelung mit bbbike-Code vermeiden
		    my $bikepwr_time_etappe =
		      ( $etappe / bikepwr_get_v($wind, $power[$i]));
		    $bikepwr_time[$i] += $bikepwr_time_etappe;
		}
	    }
	}

	my(@strnames) = $net->route_to_name($r->path);
	print "<center>" unless $printmode;
	print "<table bgcolor=\"#ffcc66\"";
	if ($printmode) {
	    print " width=$printwidth";
	}
	print "><tr><td>${fontstr}Route von <b>" .
	  stadtplan_link($startname,
			 $q->param('startplz')||"", $q->param('startisort'))
	    . "</b> ";
	if (defined $vianame && $vianame ne '') {
	    print "&uuml;ber <b>" .
	      stadtplan_link($vianame,
			     $q->param('viaplz')||"", $q->param('viaisort'))
		. "</b> ";
	}
	print "bis <b>" .
	  stadtplan_link($zielname,
			 $q->param('zielplz')||"", $q->param('zielisort')) 
	    . "</b>$fontend</td></tr></table><br>\n";
	print "<table";
	if ($printmode) {
	    print " width=$printwidth";
	}
	print ">\n";
	printf "<tr><td>${fontstr}L&auml;nge:$fontend</td><td>${fontstr}%.2f km$fontend</td>\n", $r->len/1000;
	print
	  "<tr><td>${fontstr}Fahrzeit:$fontend</td>";
	foreach my $speed (qw(10 15 20 25)) {
	    print "<td>$fontstr" . make_time($r->len/1000/$speed)
	      . "h (bei $speed km/h)";
	    print "," if $speed != 25;
	    print "$fontend</td>";
	    if ($speed == 15) {
		print "</tr><tr><td></td>";
	    }
	}
	print "<tr>\n";
	print "$fontend</td></tr>";
	if ($bp_obj and $bikepwr_time[0]) {
	    print
	      "<tr><td></td><td>$fontstr",
	      make_time($bikepwr_time[0]/3600) . "h (bei $power[0] W),",
	      "$fontend</td><td>$fontstr",
	      make_time($bikepwr_time[1]/3600) . "h (bei $power[1] W),",
	      "$fontend</td><td>$fontstr ",
	      make_time($bikepwr_time[2]/3600) . "h (bei $power[2] W)",
	      "$fontend</td></tr>";
	}
	print "</table>\n";
	if (defined $r->ampeln) {
	    print $r->ampeln . " Ampeln auf der Strecke.<br>\n";
	}
	print "</center>\n" unless $printmode;
	print "<hr>";
	my $line_fmt;
	my($next_entf, $ges_entf_s, $next_winkel, $next_richtung);
	if (!$bi->{'can_table'}) {
	    if ($bi->{'mobile_device'}) {
		$line_fmt = "%s %s %s (ges.:%s)\n";
	    } else {
		$line_fmt = "%-13s %-24s %-31s %-8s\n";
	    }
	    print "<pre>";
	    ($next_entf, $ges_entf_s, $next_winkel, $next_richtung)
	      = ("", "", undef, "");
	} else {
	    # Ist width=... bei Netscape4 buggy? Das nachfolgende Attribut
	    # ignoriert font-family.
	    #   width=\"90%\"
	    print "<center>" unless $printmode;
	    print "<table";
	    if ($printmode) {
		print " border=1 width=$printwidth";
	    } else {
		print " align=center";
		if (1 || !$bi->{'can_css'}) { # XXX siehe Kommentar oben (css...)
		    print " bgcolor=\"#ffcc66\"";
		}
	    }
	    print "><tr><th>${fontstr}Etappe$fontend</th><th>${fontstr}Richtung$fontend</th><th>${fontstr}Stra&szlig;e$fontend</th><th>${fontstr}Gesamt$fontend</th></tr>\n";
	    ($next_entf, $ges_entf_s, $next_winkel, $next_richtung)
	      = ("&nbsp;", "&nbsp;", undef, "&nbsp;");
	}
	my $ges_entf = 0;
	for(my $i = 0; $i <= $#strnames; $i++) {
	    my $strname;
	    my($entf, $winkel, $richtung)
	      = ($next_entf, $next_winkel, $next_richtung);
	    ($strname, $next_entf, $next_winkel, $next_richtung)
	      = @{$strnames[$i]};
	    if ($i > 0) {
		if (!$winkel) { $winkel = 0 }
		$winkel = int($winkel/10)*10;
		if ($winkel < 30) {
		    # ein Space, damit bgcolor ausgefllt wird
		    $richtung = (!$bi->{'can_table'} ? "" : "&nbsp;");
		} else {
		    $richtung = 
		      ($winkel <= 45 ? 'halb' : '') . 
			($richtung eq 'l' ? 'links ' : 'rechts ') .
			  "($winkel) " . Strasse::de_artikel($strname);
		}
		$ges_entf += $entf;
		$ges_entf_s = sprintf "%.1f km", $ges_entf/1000;
		$entf = sprintf "nach %.2f km", $entf/1000;
	    } elsif ($#{ $r->path } > 1) {
		# XXX main:: ist haesslich
		$richtung = "nach " . 
		    uc(main::opposite_direction
		       (main::line_to_canvas_direction
			(@{ $r->path->[0] },
			 @{ $r->path->[1] })));
	    }

	    if (!$bi->{'can_table'}) {
		printf $line_fmt,
		  $entf, $richtung, string_kuerzen($strname, 31), $ges_entf_s;
	    } else {
		print "<tr><td nowrap>$fontstr$entf$fontend</td><td>$fontstr$richtung$fontend</td><td>$fontstr$strname$fontend</td><td nowrap>$fontstr$ges_entf_s$fontend</td></tr>\n";
	    }
	}
	$ges_entf_s = sprintf "%.1f km", ($ges_entf+$next_entf)/1000;
	my $entf = sprintf "nach %.2f km", $next_entf/1000;
	if (!$bi->{'can_table'}) {
	    printf $line_fmt, $entf, "angekommen!", "", $ges_entf_s;
	    print "</pre>\n";
	} else {
	    print
	      "<tr><td>$fontstr$entf$fontend</td><td>${fontstr}angekommen!$fontend</td><td>&nbsp;</td><td>$fontstr$ges_entf_s$fontend</td></tr>\n";

	    if (!$bi->{'text_browser'} && !$printmode) {
		my $qq = new CGI $q->query_string;
		$qq->param('printmode', 1);
		print
		    "<tr><td></td><td></td><td></td><td align=center bgcolor=white>",
		    "<a target=printwindow href=\"$bbbike_script?" . $qq->query_string . "\">" .
		    "<img src=\"$bbbike_images/printer.gif\" " .
		    "width=16 height=16 border=0 alt=Druckvorlage></a></td></tr>";
	    }

	    print "</table>\n";
	    print "</center>\n" unless $printmode;
	}

	if ($printmode) {
	    print
	      "<hr><br>", $fontstr,
	      "BBBike by Slaven Rezic: ",
	      "<a href=\"$bbbike_url\">$bbbike_url</a><br>\n",
	      "<script><!--\nprint();\n",
              "// --></script>\n";
	    goto END_OF_HTML;
	}

	if (!$bi->{'mobile_device'}) {
	    my $string_rep = $r->as_string;
	    my $kfm_bug = ($q->user_agent =~ m|^Konqueror/1.0|i);
	    if ($bi->{'can_javascript'}) {
		print <<EOF;
<script language="javascript"><!--
function show_map() {
    var geom = "640x480";
    for (var i=0; i < document.showmap.geometry.length; i++) {
	if (document.showmap.geometry[i].checked) {
	    geom = document.showmap.geometry[i].value;
	    break;
	}
    }
    var x_y = geom.split("x");
// XXX height/width an aktuelle Werte anpassen
// XXX bei innerHeight/Width wird bei Netscape4 leider java gestartet?! (check!)
    var x = Math.floor(x_y[0])+15;
    var y = Math.floor(x_y[1])+15;
    var menubar     = "no";
    // Menubar immer anzeigen ... damit Speichern und Drucken mglich ist
    if (true || document.forms["showmap"].elements["outputtarget"].checked) {
	y += 27;
	menubar = "yes";
    }
    var w = window.open("$bbbike_html/pleasewait.html", "BBBikeGrafik",
			"height=" + y + ",width=" + x +
			",locationbar=no,menubar=" + menubar +
			",screenX=20,screenY=20");
    w.focus();
    return true;
}
// --></script>
EOF
	    }
            # XXX Mit GET statt POST gibt es zwar einen hlichen GET-String
	    # und vielleicht knnen lange Routen nicht gezeichnet werden,
	    # dafr gibt es keine Cache-Probleme mehr.
	    my $post_bug = 1; # XXX fr alle aktivieren
	    #$post_bug = 1 if ($kfm_bug); # XXX war mal nur fr kfm
	    print "<hr><form name=showmap method=" .
		($post_bug ? "get" : "post");

#XXX bei FCGI Grafik mit .cgi statt .fcgi zeichnen
# Dafr gibt es zwei Grnde:
# 1) wird (glaube ich) das Skript fr andere Zugriffe blockiert, wenn
#    gerade die Bilderzeugung luft, und das ist mittlerweile der einzige
#    zeitintensive Prozess
# 2) Gibt es einen Bug entweder in mod_fcgi oder in FCGI.pm, so dass
#    0-Bytes aus dem Stream entfernt werden. Ein GIF kann somit nicht
#    ausgegeben werden.
#
#	print " target=\"BBBikeGrafik\" action=\"$bbbike_script\"";
	    print " target=\"BBBikeGrafik\" action=\"$bbbike_script_cgi\"";
	    if ($q->user_agent =~ m#(Mozilla/[4-9])#i) {
		print " onsubmit='return show_map();'";
	    }
	    print ">\n";
	    print "<input type=submit value=\"Grafik zeichnen\"> <font size=-1>(neues Fenster wird ge&ouml;ffnet)</font>";
	    print " <input type=checkbox name=outputtarget value='print'> f&uuml;r Druck optimieren";
	    print "<br>\n";
	    print "<input type=hidden name=coords value=\"$string_rep\">";
	    print "<input type=hidden name=startname value=\"" .
		($kfm_bug ? CGI::escape($startname) : $startname) . "\">";
	    print "<input type=hidden name=zielname value=\"" .
		($kfm_bug ? CGI::escape($zielname) : $zielname) . "\">";
	    if (@weather_res) {
		eval {
		    local $SIG{'__DIE__'};
		    require Met::Wind;
		    print "<input type=hidden name=windrichtung value=\"" .
			$weather_res[4] . "\">";
		    print "<input type=hidden name=windstaerke value=\"" .
		      Met::Wind::wind_velocity([$weather_res[5], 'm/s'],
					       'beaufort')
			  . "\">";
		};
	    }

	    print <<EOF;
<script language="javascript"><!--
function all_checked() {
    var all_checked_flag = false;
    var elems = document.forms["showmap"].elements;
    for (var e = 0; e < elems.length; e++) {
	if (elems[e].name == "draw" &&
	    elems[e].value == "all" &&
	    elems[e].checked) {
	    all_checked_flag = true;
	    break;
	}
    }
    for (var e = 0; e < elems.length; e++) {
	if (elems[e].name == "draw") {
	    if (all_checked_flag) {
		elems[e].checked = true;
	    } else {
		elems[e].checked = (elems[e].value == "str" ||
				    elems[e].value == "title");
	    }
	}
    }
}
// --></script>
EOF

	    print "<table><tr><td>$fontstr<b>Bildgr&ouml;&szlig;e:</b>$fontend</td>\n";
	    foreach my $geom ("400x300", "640x480", "800x600", "1024x768") {
		print
		    "<td><input type=radio name=geometry value=\"$geom\"",
		    ($geom eq '640x480' ? " checked" : ""),
		    ">$fontstr $geom  $fontend</td>\n";
	    }
	    print "<tr><td>$fontstr<b>Details:</b>$fontend</td>";
	    my @draw_details = 
		(['Stra&szlig;en',  'str',    1],
		 ['S-Bahn',         'sbahn',  0],
		 ['U-Bahn',         'ubahn',  0],
		 ['Gew&auml;sser',  'wasser', 0],
		 ['Ampeln',         'ampel',  0],
		 );
	    if ($multiorte) {
		push @draw_details, ['Orte', 'ort', 0];
	    }
	    push
		@draw_details, 
		['Titel',          'title',  1],
		#['Wind',           'wind',   0], # XXX not yet
		['Alles',          'all',    0];
	    foreach my $draw (@draw_details) {
		my $text;
		if ($draw->[0] eq 'S-Bahn' && !$bi->{'text_browser'}) {
		    $text = "<img src=\"$bbbike_images/sbahn.gif\" width=15 height=15 border=0 alt=S>-Bahn";
		} elsif ($draw->[0] eq 'U-Bahn' && !$bi->{'text_browser'}) {
		    $text = "<img src=\"$bbbike_images/ubahn.gif\" width=15 height=15 border=0 alt=U>-Bahn";
		} else {
		    $text = $draw->[0];
		}
		print
		    "<td><input type=checkbox name=draw value=$draw->[1]",
		    ($draw->[2] ? " checked" : ""),
		    ($draw->[1] eq 'all' ? " onclick=\"all_checked()\"" : ""),
		    ">$fontstr $text $fontend</td>\n";
	    }
	    if ($lstr || $multiorte) {
		print "<input type=hidden name=draw value=umland>\n";
	    }
	    print "</table>\n";
	    print "<p>";
	    print <<EOF;
<font size=-1>Die Dateigr&ouml;&szlig;e der Grafik betrgt je nach
Bildgr&ouml;&szlig;e und Detailreichtum 15 bis 50 kB.
EOF
            print window_open("$bbbike_html/legende.html", "BBBikeLegende",
			      "dependent,height=392,resizable" .
			      "screenX=400,screenY=80,scrollbars,width=440")
		. "Legende.</a></font>\n";
	}

	print "</form>\n";

	print "<hr><form action=\"$bbbike_script\">\n";
	print "<input type=hidden name=startc value=\"$zielcoord\">";
	print "<input type=hidden name=zielc value=\"$startcoord\">";
	print "<input type=hidden name=startname value=\"$zielname\">";
	print "<input type=hidden name=zielname value=\"$startname\">";
	if (defined $viacoord && $viacoord ne '') {
	    print "<input type=hidden name=viac value=\"$viacoord\">";
	    print "<input type=hidden name=vianame value=\"$vianame\">";
	}
	foreach my $param ($q->param) {
	    if ($param =~ /^pref_/) {
		print "<input type=hidden name=$param value=\"".
		    $q->param($param) ."\">";
	    }
	}
	print "<input type=submit value=\"R&uuml;ckweg\">";
	hidden_smallform();
	print "</form>\n";

	if ($show_start_ziel_url) {
	    my $qq = new CGI $q->query_string;
	    foreach (qw(viac vianame alternative)) {
		$qq->delete($_);
	    }
	    my $qqq = new CGI $qq->query_string;
	    foreach (qw(zielc zielname)) {
		$qqq->delete($_);
	    }
	    print " Neue Anfrage: ";
	    print "<a href=\"$bbbike_script?" .
		$qqq->query_string . "\">Start beibehalten</a>";
	    print ", ";
	    $qqq = new CGI $qq->query_string;
	    foreach (qw(startc startname)) {
		$qqq->delete($_);
	    }
	    print "<a href=\"$bbbike_script?" .
		$qqq->query_string . "\">Ziel beibehalten</a>";
	    print ", ";
	    print "<a href=\"$bbbike_script?begin=1\">Start und Ziel neu eingeben</a>";
	    print ", ";
	    $qqq = new CGI $qq->query_string;
	    foreach (qw(c name)) {
		$qqq->param("start$_", $qqq->param("ziel$_"));
		$qqq->delete("ziel$_");
	    }
	    print "<a href=\"$bbbike_script?" .
		$qqq->query_string . "\">Ziel als Start</a>";
	    print "<br>";
	}

	print "<hr>\n";

	# Andere Alternativen ausgeben
	if (@r > 1) {
	    my $i;
	    print "Weitere Alternativen:<br><ul>\n";
	    for($i = 0; $i <= $#r; $i++) {
		print "<li>";
		my $len = sprintf "%.3f km", $r[$i]->len/1000;
		if ((defined $alternative  && $i == $alternative) ||
		    (!defined $alternative && $i == 0)) {
		    print "diese Strecke ($len)";
		} else {
		    my $qq = new CGI $q->query_string;
		    $qq->param('startc',    $startcoord);
		    $qq->param('startname', $startname);
		    $qq->param('viac',      $viacoord);
		    $qq->param('vianame',   $vianame);
		    $qq->param('zielc',     $zielcoord);
		    $qq->param('zielname',  $zielname);
		    $qq->param('alternative', $i);
		    print "<a href=\"$bbbike_script?" . $qq->query_string . "\">";
		    print
		      ($i == 0 ? "beste Alternative" : "Alternative $i");
		    print " ($len)</a>";
		}
		print "\n";
	    }
	    print "</ul><hr>\n";
	}

    }

    if (@weather_res) {
	my(@res) = @weather_res;
	print "<center><table border=0 bgcolor=\"#d0d0d0\">\n";
	print "<tr><td colspan=2>${fontstr}<b>" . link_to_met() . "Aktuelle Wetterdaten ($res[0], $res[1])</a></b>$fontend</td>";
	print "<tr><td>${fontstr}Temperatur:$fontend</td><td>${fontstr}$res[2] C$fontend</td></tr>\n";
	print "<tr><td>${fontstr}Windrichtung:$fontend</td><td>${fontstr}$res[4]$fontend</td></tr>\n";
	my($kmh, $windtext);
	eval { local $SIG{'__DIE__'};
	       require Met::Wind;
	       $kmh      = Met::Wind::wind_velocity([$res[5], 'm/s'],
						    'km/h');
	       $windtext = Met::Wind::wind_velocity([$res[5], 'm/s'],
						    'text_de');
	   };
	print "<tr><td>${fontstr}Windgeschwindigkeit:$fontend</td><td>${fontstr}";
	if (defined $kmh) {
	    print "$kmh km/h";
	} else {
	    print "$res[5] m/s";
	}
	if (defined $windtext) {
	    print " ($windtext)";
	}
	print "$fontend</td></tr>\n";
	print "</table></center><hr>";
    }

    footer();

  END_OF_HTML:
    print $q->end_html;
}

sub user_agent_info {
    $bi = new BrowserInfo $q;
#    $bi->emulate("wap"); # XXX put your favourite emulation
    $fontstr = ($bi->{'can_css'} ? '' : "<font face=\"$font\">");
    $fontend  = ($bi->{'can_css'} ? '' : "</font>");
}

sub show_user_agent_info {
    $bi->show_info('complete');
    $bi->show_server_info;
}

sub stadtplan_link {
    my($strname, $plz, $is_ort) = @_;
    if ($is_ort) {
	$strname;
    } else {
	my $stadtplan_url = "http://www.stadtplandienst.de/query";
	my @aref;
	foreach my $s (split(m|/|, $strname)) {
	    # Text in Klammern entfernen:
	    (my $str_plain = $s) =~ s/\s+\(.*\)$//;
	    $str_plain = CGI::escape($str_plain);
	    push @aref,
	    "<a target=\"_blank\" href=\"$stadtplan_url?ORT=b&STR=$str_plain" . 
	      (defined $plz ? "&PLZ=$plz" : "") . "\">$s</a>";
	}
	join("/", @aref);
    }
}

sub string_kuerzen {
    my($strname, $len) = @_;
    if (length($strname) <= $len) {
	$strname;
    } else {
	substr($strname, 0, $len-3)."...";
    }
}

sub draw_route_from_fh {
    my $fh = shift;

    my $file = "$tmp_dir/bbbike.cgi.upload.$$";
    open(OUT, ">$file") or die "Can't write to $file: $!";
    while(<$fh>) {
	print OUT $_;
    }
    close OUT;

    require Route;
    my $res;
    eval {
	$res = Route::load($file, { }, -fuzzy => 1);
    };
    my $err = $@;
    unlink $file;

    if ($res->{RealCoords}) {
	$q->param('draw', 'all');
	$q->param('scope', 'wideregion');
	$q->param('geometry', "800x600");
	$q->param('coords', join(";", map { "$_->[0],$_->[1]" }
				 @{ $res->{RealCoords} }));
	$q->delete('routefile');
	$q->delete('routefile_submit');
	draw_route();
    } else {
	print $q->header(@no_cache);
	print "Dateiformat nicht erkannt: $err";
    }
}

sub draw_route {
    my(%args) = @_;

    my @cache = (exists $args{-cache} ? @{ $args{-cache} } : @no_cache);

    $q->param("scope", ($use_umland_jwd ? 'wideregion' :
			($use_umland    ? 'region'     :
			                  'city')));
    my $draw;
    eval {
	local $SIG{'__DIE__'};
	require BBBikeDraw;
	$draw = new_from_cgi BBBikeDraw $q,
	                     MakeNet => \&make_netz;
    };
    if ($@) {
	print 
	  $q->header(-type => 'text/plain',
		     @no_cache,
		    ),
	  "Fehler beim require von BBBikeDraw: $@";
	exit 0;
    }

    print $q->header(-type => 'image/' . $draw->{ImageType},
		     @cache,
		    );
    eval { $draw->dimension_from_route() };
    return if $@;
    $draw->create_transpose();
    $draw->draw_wind(); # see comment in BBBikeDraw
    $draw->draw_map();
    $draw->draw_route();
    $draw->flush();
}

sub draw_map {
    my(%args) = @_;
    my($part, @dim);
    my($x, $y);
    if (exists $args{'-x'} and exists $args{'-y'}) {
	($x, $y) = ($args{'-x'}, $args{'-y'});
	$part = sprintf("%02d-%02d", $x, $y);
	@dim  = xy_to_dim($x, $y);
    } else {
	die "No x/y set";
    }

    print $q->header(@weak_cache) unless $args{-quiet};

    if (!@dim) { die "No dim set" }

    my($img_url, $img_file);
    my $map_file = "$mapdir_fs/berlin_map_$part.map";

    my $create = 1;
    my $ext;

    my $set_img_name = sub {
	$img_file = "$mapdir_fs/berlin_map_$part.$ext";
	$img_url  = "$mapdir_url/berlin_map_$part.$ext";
    };

    if (!$args{'-force'}) {
	foreach (qw(png gif)) {
	    $ext = $_;
	    next if $ext eq 'png' and !$bi->{'can_png'};
	    $set_img_name->();
	    if (-s $img_file && -s $map_file) {
		my(@img_file_stat)   = stat($img_file);
		if (defined $img_file_stat[9]) {
		    my(@map_file_stat)   = stat($img_file);
		    if (defined $map_file_stat[9]) {
			my(@bbbike_cgi_stat) = stat($0);
			my(@strassen_stat)   = stat($str->{File});
			my $to_create_time =
			  min($img_file_stat[9], $map_file_stat[9]);
			my $check_time = 
			  ($check_map_time == 0 ? 0 :
			   ($check_map_time == 1 ? $strassen_stat[9] :
			    max($bbbike_cgi_stat[9], $strassen_stat[9])
			   ));
			$create = ($to_create_time < $check_time);
			if ($debug) {
			    warn __LINE__ . ": time_exist=$to_create_time, " .
			      "check_time=$check_time, create=$create\n";
			}
		    } elsif ($debug) {
			warn __LINE__ . ": Can't stat $map_file: $!\n";
		    }
		} elsif ($debug) {
		    warn __LINE__ . ": Can't stat $img_file: $!\n";
		}
		last if (!$create);
	    } elsif ($debug) {
		warn __LINE__ .  ": $img_file or $img_url empty\n";
	    }
	}
    }

    if ($create) {
	$ext = $graphic_format;
	$set_img_name->();
    }

    if ($create || !-r $img_file || -z $img_file || !-r $map_file) {
	eval {
	    local $SIG{'__DIE__'};
	    require BBBikeDraw;
	    open(IMG, ">$img_file") or confess "Fehler: Die Karte $img_file konnte nicht erstellt werden.<br>\n";
	    chmod 0644, $img_file;
	    open(MAP, ">$map_file") or confess "Fehler: Die Map $map_file konnte nicht erstellt werden.<br>\n";
	    chmod 0644, $map_file;
	    $q->param('geometry', $detailwidth."x".$detailheight);
	    $q->param('draw', 'str', 'ubahn', 'sbahn', 'wasser');
	    $q->param('drawwidth', 1);
	    # XXX Argument sollte bergeben werden (wird sowieso noch nicht
	    # verwendet, bis auf berprfung des boolschen Wertes)
	    $q->param('strlabel', 'str:HH,H');#XXX if $args{-strlabel};
	    my $draw = new_from_cgi BBBikeDraw($q, Fh => \*IMG);
	    $draw->set_dimension(@dim);
	    $draw->create_transpose();
	    print "Create $img_file...\n" if $args{-logging};
	    $draw->draw_map();
	    if ($create_imagemap) {
		$draw->make_imagemap(\*MAP);
	    }
	    $draw->flush();
	    $q->delete('draw');
	    $q->delete('geometry');
	    close MAP;
	    close IMG;
	};
	warn __LINE__ . ": Warnung: $@<br>\n" if $@;
    }

    unless ($args{-quiet}) {

 	my $type = $q->param('type') || '';

	my $script = <<EOF;
function jump_to_map() {
    window.location.hash = "mapbegin";
}
EOF

	header(-script => $script,
	       -onLoad => 'jump_to_map()');
	print "<b><a name='mapbegin'>" .
	      ucfirst($type) . "-Kreuzung</a></b> ausw&auml;hlen:<br>\n";
	print "<form action=\"$bbbike_script\">\n";

	foreach ($q->param) {
	    unless ($_ eq 'type') {
		print "<input type=hidden name=$_ value=\""
		  . $q->param($_) . "\">\n";
	    }
	}
	print "<input type=hidden name=detailmapx value=\"$x\">\n";
	print "<input type=hidden name=detailmapy value=\"$y\">\n";
	print "<input type=hidden name=type value=\"$type\">\n";
	print "<center><table>";

	# obere Zeile
	if ($y > 0) {
	    print "<tr><td align=right>";
	    if ($x > 0) {
		print "<input type=submit name=movemap value=\"Nordwest\">";
	    }		
	    print "</td><td align=center><input type=submit name=movemap value=\"Nord\"></td>\n";
	    if ($x < $xgridnr-1) {
		print "<td align=left><input type=submit name=movemap value=\"Nordost\"></td>";
	    }
	    print "</tr>\n";
	}

	# mittlere Zeile
	print "<tr><td align=right>";
	if ($x > 0) {
	    print "<input type=submit name=movemap value=\"West\">";
 	}
	print
	  "</td><td><input type=image title='' name=detailmap ",
	  "src=\"$img_url\" alt=\"\" border=0 ",
	  ($use_imagemap ? "usemap=\"#map\" " : ""),
	  "align=middle width=$detailwidth height=$detailheight alt=\"\">",
	  "</td>\n";
	if ($x < $xgridnr-1) {
	    print "<td align=left><input type=submit name=movemap value=\"Ost\"></td>";
 	}
	print "</tr>\n";

	# untere Zeile
	if ($y < $ygridnr-1) {
	    print "<tr><td align=right>";
	    if ($x > 0) {
		print "<input type=submit name=movemap value=\"Sdwest\">";
	    }		
	    print "</td><td align=center><input type=submit name=movemap value=\"Sd\"></td>";
	    if ($x < $xgridnr-1) {
		print "<td align=left><input type=submit name=movemap value=\"Sdost\"></td>";
	    }
	    print "</tr>\n";
 	}
	print "</table>";
	print "<input type=submit name=Dummy value=\"&lt;&lt; Zur&uuml;ck\">";
	print "</center>";
	print <<EOF;
<script language=javascript>
<!--
function s(text) {
  self.status=text;
  return true;
}
// -->
</script>
EOF
	if ($use_imagemap) {
	    open(MAP, $map_file)
	      or confess "Fehler: Die Map $map_file konnte nicht geladen werden.\n<br>";
	    while(<MAP>) {
		print $_;
	    }
	    close MAP;
	}
	print "</form>\n";
	footer();
	print $q->end_html;
    }
}

sub min {
    my $min;
    foreach (@_) {
	if (!defined $min || $_ < $min) { $min = $_ }
    }
    $min;
}

sub max {
    my $max;
    foreach (@_) {
	if (!defined $max || $_ > $max) { $max = $_ }
    }
    $max;
}

# Stellt fr den x/y-Index der berlin_small-Karte die zugehrige
# Dimension fr BBBikeDraw fest.
sub xy_to_dim {
    my($x, $y) = @_;
    ($x*$xgridwidth*$xm+$x0, ($x+1)*$xgridwidth*$xm+$x0,
     $y0-($y+1)*$ygridwidth*$ym, $y0-$y*$ygridwidth*$ym,
    );
}

# Fr einen Punkt aus der Detailmap wird die am nchsten liegende
# Kreuzung festgestellt. Zurckgegeben wird die Koordinate der
# Kreuzung "(x,y)".
sub detailmap_to_coord {
    my($index_x, $index_y, $map_x, $map_y) = @_;
    my($x, $y) = 
      ($index_x*$xgridwidth*$xm+$x0 + ($map_x*$xm*$xgridwidth)/$detailwidth,
       $y0-$index_y*$ygridwidth*$ym - ($map_y*$ym*$ygridwidth)/$detailheight,
      );
    new_kreuzungen();
    my(@nearest) = $kr->nearest_loop($x, $y);
    return $nearest[0];
}

sub all_crossings {
    if (scalar keys %crossings == 0) {
	%crossings = $multistr->all_crossings(RetType => 'hash',
					      UseCache => 1);
    }
}

sub new_kreuzungen {
    if (!$kr) {
	all_crossings();
	$kr = new Kreuzungen Hash => \%crossings;
	if ($lstr) {
	    my(%lstr_crossings) = $lstr->all_crossings(RetType => 'hash',
						       UseCache => 1);
	    $kr->add(Hash => \%lstr_crossings);
	}
	$kr->make_grid;
    }
}

sub crossing_text {
    my $c = shift;
    all_crossings();
    if (exists $crossings{$c}) {
	join("/", @{ $crossings{$c} });
    } else {
	new_kreuzungen();
	my(@nearest) = $kr->nearest_coord($c);
	if (@nearest and exists $crossings{$nearest[0]}) {
	    join("/", @{ $crossings{$nearest[0]} });
	} else {
	    "???";
	}
    }
}

# Gibt den Straennamen fr type=start/via/ziel zurck --- entweder
# aus startname oder abgeleitet aus startc
sub name_from_cgi {
    my($q, $type) = @_;
    if (defined $q->param($type . "name") and
	$q->param($type . "name") ne '') {
	$q->param($type . "name");
    } elsif (defined $q->param($type . "c")) {
	crossing_text($q->param($type . "c"));
    } else {
	undef;
    }
}

sub make_time {
    my($h_dec) = @_;
    my $h = int($h_dec);
    my $m = int(($h_dec-$h)*60);
    sprintf "%d:%02d", $h, $m;
}

# falls die Koordinaten nicht exakt existieren, wird der nchste Punkt
# gesucht und gesetzt
sub fix_coords {
    my($startcoord, $viacoord, $zielcoord) = @_;
    foreach my $varref (\$startcoord, \$viacoord, \$zielcoord) {
	next if (!defined $$varref or 
		 $$varref eq ''    or
		 exists $net->{Net}{$$varref});
	if (!defined $kr) {
	    new_kreuzungen();
	}
	my(@nearest) = $kr->nearest_coord($$varref);
	if (@nearest) {
	    $$varref = $nearest[0];
	}
    }
    ($startcoord, $viacoord, $zielcoord);
}

sub limit_processes {
    dbmopen(%proc, "$tmp_dir/bbbike-limit", 0640);
    my $i;
  TRY: while(1) {
	for ($i = 0; $i < $max_proc; $i++) {
	    if (defined $proc{$i} && $proc{$i} ne '') {
		next if kill 0, $proc{$i};
	    }
	    $proc{$i} = $$;
	    last TRY;
	}

	(my $slow_cgi = $bbbike_url) =~ s/-fast//;
	undef $slow_cgi if ($slow_cgi eq $bbbike_url);

	if ($auto_switch_slow && $slow_cgi) {
	    print $q->redirect(-uri => $slow_cgi, @no_cache);
	    exit;
	}

	print $q->header(@no_cache);
	header();
	print <<EOF;
Der Server ist berlastet. Bitte ein paar Minuten spter versuchen
EOF
        if ($slow_cgi) {
	    print "oder das <a href=\"$slow_cgi\">langsamere Interface</a> benutzen";
        } 
        print <<EOF;
!<p>
<small>Anzahl der erlaubten Prozesse: $max_proc</small>
<p>
EOF
        footer();
	print $q->end_html;
	exit;
    }
    dbmclose(%proc);
    $i;
}

sub set_process {
    my $slot = shift;
    dbmopen(%proc, "$tmp_dir/bbbike-limit", 0640);
    $proc{$slot} = $$;
    dbmclose(%proc);
}

sub start_weather_proc {
    my(@stat) = stat("$tmp_dir/wettermeldung");
    if (!defined $stat[9] or $stat[9]+30*60 < time()) {
	my @weather_cmdline = (@weather_cmdline,
			       '-o', "$tmp_dir/wettermeldung");
	if ($^O eq 'MSWin32') { # XXX Austesten
	    eval q{
		require Win32::Process;
		unlink "$tmp_dir/wettermeldung";
		Win32::Process::Create($proc,
				       $weather_cmdline[0],
				       @weather_cmdline,
				       0, Win32::Process::CREATE_NO_WINDOW,
				       $tmp_dir);
	    };
	} else {
	    eval {
		local $SIG{'__DIE__'};
		my $weather_pid = fork();
		if (defined $weather_pid and $weather_pid == 0) {
		    open(STDERR, ">/dev/null");
		    unlink "$tmp_dir/wettermeldung";
		    exec @weather_cmdline;
		    exit 1;
		}
	    };
	}
    }
}

sub gather_weather_proc {
    my @res;
    my(@stat) = stat("$tmp_dir/wettermeldung");
    if (defined $stat[9] and $stat[9]+30*60 > time()) { # Aktualitt checken
	if (open(W, "$tmp_dir/wettermeldung")) {
	    chomp(my $line = <W>);
	    @res = split(/\|/, $line);
	    close W;
	}
    }
    @res;
}

sub header {
    my(%args) = @_;
    if (!exists $args{-title}) {
	$args{-title} = "BBBike";
    }
    no strict;
    local *cgilink = ($CGI::VERSION <= 2.36
		      ? \&CGI::link
		      : \&CGI::Link);
    if ($bi->{'text_browser'} && !$smallform) {
	$args{-head} =
	  [cgilink({-rel => 'Help',
		    -href => "$bbbike_script?info=1"}),
	   cgilink({-rel => 'Start',
		    -href => "$bbbike_script?begin=1"}),
	   (defined $args{-up}
	    ? cgilink({-rel => 'Up', -href => $args{-up}}) : ()),
          ];
	if ($args{-contents}) {
	    push @{$args{-head}}, cgilink({-rel => 'Contents',
					   -href => $args{'-contents'}});
	}
    }
    delete @args{qw(-contents -up)};
    if ($bi->{'can_css'} && !exists $args{-style}) {
	$args{-style} = <<EOF;
<!--
$std_css
-->
EOF
    }
    if (!$bi->{'can_javascript'}) {
	delete $args{-script};
	delete $args{-onload};
    }

    if (!$smallform) {
	print $q->start_html
	    (%args,
	     -BGCOLOR => '#ffffff',
	     -meta=>{'keywords'=>'berlin fahrrad route bike karte suche',
		     'copyright'=>'(c) 1998 Slaven Rezic',
		    },
	     -author => $BBBike::EMAIL,
	    );
	print "<font face=\"$font\">\n";
	print "<h1><ilayer left=200>$args{-title}</ilayer>";
	print "<ilayer left=175 top=5><img alt=\"\" src=\"$bbbike_images/srtbike.gif\" hspace=10></ilayer>";
	print "</h1>\n";
    } else {
	print $q->start_html;
	print "<h1>BBBike</h1>";
    }
}

sub footer {
# ?begin anscheinend notwendig (Bug in Netscape3, Solaris2?)
    my $smallformstr = ($q->param('smallform')
			? '&smallform=' . $q->param('smallform')
			: '');
    print "<center><table ";
    if (1 || !$bi->{'can_css'}) { # XXX siehe oben Kommentar am Anfang von "sub search_*" bzgl. css
	print "bgcolor=\"#ffcc66\" ";
    }
    print "cellpadding=3>\n";
    print <<EOF;
<tr>
<td align=center>${fontstr}bbbike.cgi $VERSION${fontend}</td>
<td align=center>${fontstr} <a target="_top" href="mailto:@{[ $BBBike::EMAIL ]}?subject=BBBike">Kontakt</a>${fontend}</td>
<td align=center>$fontstr<a target="_top" href="$bbbike_script?begin=1$smallformstr">Neue Anfrage</a>${fontend}</td>
EOF
    if ($use_miniserver) {
        print <<EOF;
<td align=center>$fontstr<a target="_top" href="$bbbike_url">Kaltstart</a>${fontend}</td>
EOF
    }
    print <<EOF;
<td align=center>$fontstr<a target="_top" href="$bbbike_script?info=1$smallformstr">Info</a>${fontend}</td>
EOF
    print "<td align=center>$fontstr";
    print complete_link_to_einstellungen();
    print "${fontend}</td>\n";
    print <<EOF;
</table>
</center>
</font>
EOF
}

sub complete_link_to_einstellungen {
    window_open("$bbbike_script?bikepower=1", "BikePower",
		"dependent,height=400,resizable," .
		"screenX=400,screenY=40,scrollbars,width=550") .
		  "Einstellungen</a>";
}

sub link_to_met {
    "<a href=\"http://www.met.fu-berlin.de/deutsch/Wetter/meldungen.html\">";
}

sub window_open {
    my($href, $winname, $settings) = @_;
    if ($bi->{'can_javascript'} && !$bi->{'window_open_buggy'}) {
	"<a href=# onclick='window.open(\"$href\", \"$winname\"" .
	  (defined $settings ? ", \"$settings\"" : "") .
	    "); return false;'>";
    } else {
	"<a href=\"$href\" target=\"$winname\">";
    }
}

sub call_bikepower {
    print $q->header(@no_cache);
    eval q{
	require BikePower::HTML;
	print BikePower::HTML::code();
    };
    if ($@) {
	header();
	print
	  "<b>Sorry, BikePower ist anscheinend auf diesem System ",
	  "nicht installiert.</b><p>\n";
	footer();
    }
}

sub init_bikepower {
    my $q = shift;
    undef $bp_obj;
    eval {
	local $SIG{__DIE__};
	require BikePower;
	require BikePower::HTML;
	$bp_obj = BikePower::HTML::new_from_cookie($q);
	$bp_obj->given('P');
	init_wind();
    };
    # XXX warn __LINE__ .  ": Warnung: $@<br>\n" if $@;
    $bp_obj;
}

# XXX Doppelung mit bbbike-Code vermeiden
sub bikepwr_get_v { # Resultat in m/s
    my($wind, $power, $grade) = @_;
    $grade = 0 if !defined $grade; # $grade wird noch nicht verwendet XXX
    $bp_obj->grade($grade);
    $bp_obj->headwind($wind);
    $bp_obj->power($power);
    $bp_obj->calc();
    my $v = $bp_obj->velocity;
    $v;
}


#  sub max_speed {
#      my($speed_belag, $speed_radler) = @_;
#      ($speed_belag >= $speed_radler
#       ? 1
#       : $speed_radler/$speed_belag);
#  }

sub upload_button {
    print $q->header(@no_cache); # wegen dummy
    header();
    # XXX warum ist dummy notwendig???
    print $q->start_multipart_form(-method => 'post',
				   -action => "$bbbike_url?dummy=@{[ time ]}"),
          "Anzuzeigende Route-Datei:<br>\n",
	  $q->filefield(-name => 'routefile'),
	  "<br>\n",
	  $q->submit(-name => 'routefile_submit',
		     -value => 'Anzeigen'),
	  $q->endform;
    footer();
    print $q->end_html;
}

sub show_info {
    print $q->header(@weak_cache);
    header();
    my $cpan = "http://www.perl.com/CPAN";
    print <<EOF;
<center><h2>Information</h2></center>
Das Programm versucht, den krzesten Weg zwischen den gewhlten Berliner
Straen zu finden. Da <b>agrep</b> bzw. <b>String::Approx</b> verwendet wird,
muss man den Straennamen nicht vllig korrekt eintippen. Gro- und
Kleinschreibung wird ignoriert.
<p>
Bei der Suche wird auf Einbahnstraen und zeitweilig gesperrte Straen
(Potsdamer Platz!) geachtet; auf Steigungen und
Verkehrsdichte <b>nicht</b> --- vielleicht in einer spteren
Version <tt>:-)</tt>
<p>
EOF
    print
      "Falls die " . complete_link_to_einstellungen() . " ",
      "fr BikePower ausgefllt wurden, ",
      "kann mit der " . link_to_met() . "aktuellen Windgeschwindigkeit</a> die ",
      "Fahrzeit anhand von drei Leistungsstufen (50&nbsp;W, 100&nbsp;W und 200&nbsp;W) ",
      "berechnet werden.<p>\n";
    if ($use_miniserver) {
        print <<EOF;
Es gibt einen Timeout von $cgi->{'timeout'} Minuten pro Seite. Wenn
die Zeit abgelaufen ist, kann das Programm per "Kaltstart" neu
gestartet werden. Evtl. funktioniert das Programm nicht ber einen
Proxy; sollte es Probleme geben, eine <a
href="mailto:@{[ $BBBike::EMAIL ]}?subject=BBBike problems">E-Mail an mich</a>
schicken.<p>
EOF
    }
    print <<EOF;
<hr>
<b>Link auf BBBike setzen</b>: Man kann einen Link auf BBBike mit einem
bereits vordefinierten Ziel setzen. Die Vorgehensweise sieht so aus:
<ul>
 <li>Eine beliebige Route mit dem gewnschten Zielort suchen lassen. Dabei
     darf die Auswahl fr den Zielort nicht ber die Berlin-Karte erfolgen,
     sondern der Zielort muss direkt eingegeben werden.
 <li>Wenn die Route gefunden wurde, klickt man den Link "Ziel beibehalten" an.
 <li>Die URL der neuen Seite kann nun auf die eigene Homepage aufgenommen werden. Die URL msste ungefhr so aussehen:
<tt>$bbbike_url?zielname=Alexanderplatz&amp;zielplz=10178&amp;zielc=10923%2C12779</tt>
 <li>Auf Wunsch kann <tt>zielname</tt> verndert werden. Beispielsweise:
<tt>$bbbike_url?zielname=Weltzeituhr&amp;zielc=10923%2C12779</tt><br>
     Dabei sollte <tt>zielplz</tt> gelscht werden. Wenn im Namen Leerzeichen
     vorkommen, mssen sie durch <tt>+</tt> ersetzt werden.
</ul>
<hr>
<p>
EOF

    # funktioniert nur auf dem CS-Server
    my $os;
    if (open(INFO, "/usr/INFO/Rechnertabelle")) {
	my $host;
	eval q{local $SIG{'__DIE__'};
	       require Sys::Hostname;
	       $host = Sys::Hostname::hostname();
	   };
	while(<INFO>) {
	    if (/^$host:/o) {
		print "Hardware: " . (split /:/)[2] . "<p>\n";
		$os = (split /:/)[3];
		last;
	    }
	}
	close INFO;
    }
    unless (defined $os or $^O eq 'MSWin32') {
	open UNAME, "-|" or exec qw(uname -sr);
	my $uname = <UNAME>;
	close UNAME;
	if ($uname) {
	    chomp($os = "$uname");
	}
    }
    # Config ist ungenau, weil perl evtl. fr ein anderes Betriebssystem
    # compiliert wurde.
    unless (defined $os) {
	require Config;
        $os = "\U$Config::Config{'osname'} $Config::Config{'osvers'}\E";
    }
    if (defined $os) {
        print "Betriebssystem: $os\n";
        if ($os =~ /freebsd/i) {
	    print "<a href=\"http://www.freebsd.org/\"><img align=right src=\"";
	    if (-f "/cdrom/www/gifs/powerani.gif") {
		print "file:/cdrom/www/gifs/powerani.gif";
	    } else {
		print "http://www.freebsd.org/gifs/powerani.gif";
	    }
	    print "\" border=0></a>";
	}
        print "<p>";
    }
    if (defined $ENV{'SERVER_SOFTWARE'}) {
	print "HTTP-Server: $ENV{'SERVER_SOFTWARE'}\n";
	if ($ENV{'SERVER_SOFTWARE'} =~ /apache/i) {
	    print "<a href=\"http://www.apache.org/\"><img align=right src=\"";
	    if (-f "/cdrom/www/gifs/apache.gif") {
		print "file:/cdrom/www/gifs/apache.gif";
	    } else {
		print "http://www.apache.org/images/apache_pb.gif";
	    }
	    print "\" border=0></a>";
	}
	print "<p>";
    }
    print <<EOF;
Verwendete Software:
<ul>
<li><a href="$cpan">perl $]</a>
<li>perl-Module:
<ul>
<li><a href="$cpan/modules/by-module/CGI/">CGI $CGI::VERSION</a>
EOF
    if (defined $Apache::VERSION) {
	print <<EOF;
<li><a href="$cpan/modules/by-modules/Apache/">Apache $Apache::VERSION</a> (auch bekannt als "mod_perl")
EOF
    } elsif ($use_fcgi) {
        print <<EOF;
<li><a href="$cpan/modules/by-module/FCGI/">FCGI</a> bei der FastCGI-Version
EOF
    } else {
        print <<EOF;
<li><a href="$cpan/modules/by-module/CGI/">CGI::Base, CGI::Request, CGI::MiniSvr</a> bei der MiniServer-Version
EOF
    }
    print <<EOF;
<li><a href="$cpan/modules/by-module/GD/">GD</a> fr das Erzeugen der Grafik
<li><a href="$cpan/modules/by-module/Storable/">Storable</a>
<li><a href="$cpan/modules/by-module/String/">String::Approx</a> als <a href="ftp://ftp.cs.arizona.edu/agrep/">agrep</a>-Ersatz
</ul>
</ul>
<p>
<a href="@{[ $BBBike::DISTDIR ]}">Verzeichnis</a>, in dem sich
die aktuellesten Sourcen des kompletten BBBike-Pakets
(mit perl/Tk-Interface) befindet.<p>
<a href="http://pub.cs.tu-berlin.de/gif/bbbike_screenshot.gif">Screenshot</a>
der perl/Tk-Version.
<p>
<a href="@{[ $bbbike_url ]}?uploadpage=1">Anzeigen von GPS-Tracks oder bbr-Dateien</a><p>
Die Zuordnung der Straen zu den Postleitzahlen stammt aus der STRADA-Datei
der Post.<p>
<center>
Autor: Slaven Rezic<br>
<a href="mailto:@{[ $BBBike::EMAIL ]}">E-Mail:</a> <a href="mailto:@{[ $BBBike::EMAIL ]}">@{[ $BBBike::EMAIL ]}</a><br>
<a href="@{[ $BBBike::HOMEPAGE ]}">Homepage:</a> <a href="@{[ $BBBike::HOMEPAGE ]}">@{[ $BBBike::HOMEPAGE ]}</a></a>
</center>
<p>
EOF
    footer();
    print $q->end_html;
}

